<?php
/**
*
*	Wp Lead Pages
*	(c) wpleadpages.com
*
*/
if(!defined('wlp_FILE')){
	header('HTTP/1.0 403 Forbidden');
	exit;
}

$wlp = wpleadpages::globe();
$live_tmpl = wlp_PATH.KDS.'shortcodes'.KDS.'live_editor'.KDS;

$res_data = get_option('wlp_subscriber_settings');
$responder = array();
if(!empty($res_data)){
	foreach($res_data as $k=>$v){
		if(!empty($v)) $responder[$k] = $k;
	}
}

$responsive = array(

	array(
		'name' => 'responsive',
		'label' => __( 'Responsive Options', 'wpleadpages' ).
				   '<button onclick="wlp.views.column.apply_all(this,\'responsive\')" class="float-right button button-primary" style="margin: -5px 0 20px -10px;">'.__( 'Apply for all same level columns', 'wpleadpages' ).'</button>',
		'type' => 'group',
		'params' => array(
			array(
				'name' => 'screen',
				'label' => __( 'Screen width', 'wpleadpages' ),
				'type' => 'select',
				'options' => array(
					'(max-width: 479px)' => 'Max 479px (smartphone)',
					'(min-width: 480px) and (max-width: 639px)' => '480px to 639px (phablet)',
					'(min-width: 640px) and (max-width: 767px)' => '640px to 767px (tablet mini)',
					'(min-width: 768px) and (max-width: 999px)' => '768px to 999px (tablet)',
					'(min-width: 1000px) and (max-width: 1169px)' => '1000px to 1169px (13 inch)',
					'(min-width: 1170px)' => 'Min 1170px (desktop)',
					'custom' => 'Custom',
				),
				'description' => __( 'Select screen size', 'wpleadpages' ),
			),
			array(
				'name' => 'range',
				'label' => 'Custom Screen',
				'type' => 'number_slider',
				'value' => '768|999',
				'options' => array(
					'min' => 240,
					'max' => 1920,
					'unit' => 'px',
					'range' => true
				),
				'admin_label' => true,
				'description' => __('Set Min width and Max width of screen', 'wpleadpages'),
				'relation' => array(
					'parent' => 'responsive-screen',
					'show_when' => array('custom')
				),
			),
			array(
				'name' => 'offset',
				'label' => __( 'Offset', 'wpleadpages' ),
				'type' => 'select',
				'options' => array(
					'0' => 'Inherit',
					'1' => '1 column 1/12',
					'2' => '2 columns 2/12',
					'3' => '3 columns 3/12',
					'4' => '4 columns 4/12',
					'5' => '5 columns 5/12',
					'6' => '6 columns 6/12',
					'7' => '7 columns 7/12',
					'8' => '8 columns 8/12',
					'9' => '9 columns 9/12',
					'10' => '10 columns 10/12'
				),
				'description' => __( 'Move columns to the right by increase the left margin', 'wpleadpages' )
			),
			array(
				'name' => 'columns',
				'label' => __( 'Width', 'wpleadpages' ),
				'type' => 'select',
				'options' => array(
					'0' => 'Inherit',
					'1' => '1 column 1/12',
					'2' => '2 columns 2/12',
					'3' => '3 columns 3/12',
					'4' => '4 columns 4/12',
					'5' => '5 columns 5/12',
					'6' => '6 columns 6/12',
					'7' => '7 columns 7/12',
					'8' => '8 columns 8/12',
					'9' => '9 columns 9/12',
					'10' => '10 columns 10/12',
					'11' => '11 columns 11/12',
					'12' => '12 columns 12/12'
				),
				'description' => __( 'width of column in this screen size', 'wpleadpages' )
			),
			array(
				'name' => 'important',
				//'label' => __( 'Important', 'wpleadpages' ),
				'type' => 'checkbox',
				'options' => array(
					'yes' =>  __( 'Important', 'wpleadpages' ),
				),
				'description' => __( 'Make this option as important and have a higher priority than other places', 'wpleadpages' )
			),
			array(
				'name' => 'display',
				//'label' => __( 'Hide Column', 'wpleadpages' ),
				'type' => 'checkbox',
				'options' => array(
					'hide' =>  __( 'Hide Column', 'wpleadpages' ),
				),
				'description' => __( 'Hide this column in this screen size', 'wpleadpages' )
			),
		),
		'description' => __( 'Adjust column for different screen sizes.', 'wpleadpages' )
	)

); 

$optinform_custom = array(
			array( 
					'name' => 'form_fieldname',
					'label' => 'Fields Name',
					'type' => 'text', 
					'description' => __('Autoresponder field name', 'wpleadpages'),
				),
			array( 
					'name' => 'form_fieldplaceholder',
					'label' => 'Placeholder Text',
					'type' => 'text',
					'description' => __('Enter placeholder text', 'wpleadpages'),
				),
				
		);
		
	


$wlp->add_map(

	array(

		'_value' => array(
			'name' => 'or Element',
			'description' => 'or Element',
			'icon' => 'sl-info',	   /* Class name of icon show on "Add Elements" */
			'category' => '',	  /* Category to group elements when "Add Elements" */
			'is_container' => false, /* Container has begin + end [name]...[/name] -  Single has only [name param=""] */
			'pop_width' => 580,		/* width of the popup will be open when clicking on the edit  */
			'system_only' => true, /* Use for system only and dont show up to Add Elements */
			'params' => array()
		),

		'wlp_undefined' => array(
			'name' => 'Undefined Element',
			'icon' => 'sl-flag',
			'category' => '',
			'is_container' => true,
			'pop_width' => 440,
			'system_only' => true,
			'params' => array(
				array(
					'name' => 'content',
					'label' => 'Content',
					'type' => 'textarea_html',
					'value' => 'Sample Text',
					'admin_label' => true,
				)
			)
		),

		'wlp_wp_widget' => array(
			'name' => 'Wordpress Widget',
			'icon' => 'wlp-icon-wordpress',
			'category' => '',
			'pop_width' => 450,
			'system_only' => true,
			'params' => array(
				array(
					'name' => 'data',
					'label' => 'Data',
					'type' => 'wp_widget',
					'admin_label' => true,
				)
			)
		),

		'wlp_css_box' => array(

			'name' => 'CSS Box',
			'system_only' => true,
			'params' => array(

				array(
					'name' => 'margin',
					'label' => 'Margin',
					'type' => 'css_box_tbtl'
				),
				array(
					'name' => 'padding',
					'label' => 'Padding',
					'type' => 'css_box_tbtl',
				),
				array(
					'name' => 'border',
					'label' => 'Border',
					'type' => 'css_box_border',
				),
				array(
					'name' => 'color',
					'label' => 'Text Color',
					'type' => 'colwlp_picker',
					'description' => 'Color of the text.'
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Background border radius', 'wpleadpages' ),
					'name'			=> 'wlp_bbr_box',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array(
						'min'	=> 0,
						'max'	=> 200,
						'unit' => 'px',
						'show_input'=> true
					),
					'value'			=> 0
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Font style', 'wpleadpages' ),
					'name'			=> 'font-family',
					'options'		=> array(
						'' => __( 'Select', 'wpleadpages' ),
						 
						'AllertaStencil' => __( 'AllertaStencil', 'wpleadpages' ),
						'AbrilFatface' => __( 'AbrilFatface', 'wpleadpages' ),
						'Alegreya' => __( 'Alegreya', 'wpleadpages' ),
						'Alegreya-Bold' => __( 'Alegreya-Bold', 'wpleadpages' ),
						'Anton' => __( 'Anton', 'wpleadpages' ),
						'Anke' => __( 'Anke', 'wpleadpages' ),
						'ArchitectsDaughter' => __( 'ArchitectsDaughter', 'wpleadpages' ),
						'Arvo' => __( 'Arvo', 'wpleadpages' ),
					 
						'Caliban' => __( 'Caliban', 'wpleadpages' ),
						 
						'book antiqua,palatino,serif' => __( 'Book Antiqua', 'wpleadpages' ),
						'CaveatBrush' => __( 'CaveatBrush', 'wpleadpages' ),
						'comic sans ms,sans-serif' => __( 'Comic Sans MS', 'wpleadpages' ),
						'DroidSans' => __( 'DroidSans', 'wpleadpages' ),
						'DroidSerif' => __( 'DroidSerif', 'wpleadpages' ),
						'FredokaOne' => __( 'FredokaOne', 'wpleadpages' ),
						'bcourier new,courier,monospace' => __( 'Courier New', 'wpleadpages' ), 
						'georgia,palatino,serif' => __( 'Georgia', 'wpleadpages' ),
						'impact,sans-serif' => __( 'Impact', 'wpleadpages' ),
						'josephsans' => __( 'josephsans', 'wpleadpages' ),
						'Lato' => __( 'Lato', 'wpleadpages' ),
						'Limelight' => __( 'Limelight', 'wpleadpages' ),
						'Lora' => __( 'Lora', 'wpleadpages' ),
						'lobster' => __( 'lobster', 'wpleadpages' ),
						'Monda' => __( 'Monda', 'wpleadpages' ),
						'Montez' => __( 'Montez', 'wpleadpages' ),
						'Montserrat' => __( 'Montserrat', 'wpleadpages' ),
						'Muli' => __( 'Muli', 'wpleadpages' ),
						'NotoSans' => __( 'NotoSans', 'wpleadpages' ),
						'Open Sans' => __( 'Open Sans', 'wpleadpages' ),
						'Orbitron' => __( 'Orbitron', 'wpleadpages' ),
						'Oswald' => __( 'Oswlad', 'wpleadpages' ),
						'pacifico' => __( 'pacifico', 'wpleadpages' ),
						'Poppins' => __( 'Poppins', 'wpleadpages' ),
						'PT Sans Caption Web' => __( 'PT Sans Caption Web', 'wpleadpages' ),
						'Raleway' => __( 'Raleway', 'wpleadpages' ),
						'Raleway-Bold' => __( 'Raleway-Bold', 'wpleadpages' ),
						'Raleway-ExtraBold' => __( 'Raleway-ExtraBold', 'wpleadpages' ),
						'Rancho' => __( 'Rancho', 'wpleadpages' ),
						'Righteous' => __( 'Righteous', 'wpleadpages' ),
						'Roboto' => __( 'Roboto', 'wpleadpages' ),
						'RobotoSlab' => __( 'RobotoSlab', 'wpleadpages' ),
						'RobotoSlab-Bold' => __( 'RobotoSlab-Bold', 'wpleadpages' ),
						'ShadowsIntoLight' => __( 'ShadowsIntoLight', 'wpleadpages' ),
						'Slabo 27px' => __( 'Slabo', 'wpleadpages' ),
						'SourceSansPro' => __( 'SourceSansPro', 'wpleadpages' ),
						 
						'tahoma,arial,helvetica,sans-serif' => __( 'Tahoma', 'wpleadpages' ),
						'terminal,monaco,monospace' => __( 'Terminal', 'wpleadpages' ),
						'times new roman,times,serif' => __( 'Times New Roman', 'wpleadpages' ),
						'trebuchet ms,geneva,sans-serif' => __( 'Trebuchet MS', 'wpleadpages' ),
						'TitilliumWeb' => __( 'TitilliumWeb', 'wpleadpages' ),
						 
						'Ubuntu' => __( 'Ubuntu', 'wpleadpages' ),
						'verdana,geneva,sans-serif' => __( 'Verdana', 'wpleadpages' ),
						"Barrio, cursive" => __( 'Barrio', 'wpleadpages' ),
						 
						 
					),
					'description'	=> __( 'Set font style', 'wpleadpages' ),
				),
				array(
					'name' => 'background-color',
					'label' => 'Background Color',
					'type' => 'colwlp_picker',
					'description' => 'Background color of the element.'
				),
				array(
					'name' => 'background-image-option',
					//'label' => 'Background Image',
					'type' => 'checkbox',
					'description' => 'Use a background image instead of a plain color.',
					'options' => array( 'yes' => 'Background Image' )
				),
				array(
					'name' => 'background-image',
					'label' => 'Upload Image',
					'type' => 'attach_image_url',
					'value' =>  wlp_URL.'/assets/images/get_logo.png',
					'relation' => array(
						'parent' => 'background-image-option',
						'show_when' => 'yes'
					)
				),
				array(
					'name' => 'background-repeat',
					'label' => 'BG Repeat',
					'type' => 'select',
					'options' => array(
						'' => 'Yes',
						'no-repeat' => 'No Repeat',
						'repeat-x' => 'Repeat Horizontal',
						'repeat-y' => 'Repeat Vertical'
					),
					'relation' => array(
						'parent' => 'background-image-option',
						'show_when' => 'yes'
					)
				),
				array(
					'name' => 'background-position',
					'label' => 'BG Position',
					'type' => 'select',
					'options' => array(
						'center center' => 'center center',
						'0px 0px' => '0px 0px',
						'50% 50%' => '50% 50%'
					),
					'relation' => array(
						'parent' => 'background-image-option',
						'show_when' => 'yes'
					)
				),
				array(
					'name' => 'background-attachment',
					'label' => 'BG Attachment',
					//'type' => 'text',
					//'description' => 'scroll | fixed | local | initial | inherit',
					'type' => 'select',
					'options' => array(
						'scroll' => 'scroll',
						'fixed' => 'fixed',
						'local' => 'local',
						'initial' => 'initial',
						'inherit' => 'inherit'
					),
					'relation' => array(
						'parent' => 'background-image-option',
						'show_when' => 'yes'
					)
				),
				array(
					'name' => 'background-size',
					'label' => 'BG Size',
					//'type' => 'text',
					//'description' => 'auto | length | cover | contain | initial | inherit',
					'type' => 'select',
					'options' => array(
						'auto' => 'auto',
						'length' => 'length',
						'cover' => 'cover',
						'contain' => 'contain',
						'initial' => 'initial',
						'inherit' => 'inherit',
					),
					'relation' => array(
						'parent' => 'background-image-option',
						'show_when' => 'yes'
					)
				),
				array(
					'name' => 'text-align',
					'label' => 'Text Align',
					'type' => 'select',
					'options' => array(
						'' => 'Default',
						'center' => 'Center',
						'left' => 'Left',
						'right' => 'Right',
						'justify' => 'Justify',
						'start' => 'Start',
						'inherit' => 'Inherit',
						'initial' => 'Initial',
					),
				),
				array(
					'name' => 'float',
					'label' => 'Float',
					'type' => 'select',
					'options' => array(
						'' => 'Default',
						'left' => 'Left',
						'right' => 'Right',
						'none' => 'None',
					),
				),
				array(
					'name' => 'display',
					'label' => 'Display',
					'type' => 'select',
					'options' => array(
						'' => 'Default',
						'block' => 'Block',
						'inline-block' => 'Inline Block',
						'none' => 'None',
					),
				),
				
			)

		),

		'wlp_row' => array(
			'name' => 'Row',
			'description' => __( 'Place content elements inside the row', 'wpleadpages' ),
			'category' => '',
			'title' => 'Row Settings',
			'is_container' => true,
			'css_box' => true,
			'system_only' => true,
			'live_editor' => $live_tmpl.'wlp_row.php',
			'params' => array(
			
				/*array(
					'name' => 'row_id',
					'label' => 'Row ID',
					'type' => 'text',
					'description' => __('The unique identifier of the row.', 'wpleadpages'),
				),*/
				array(
					'name' => 'full_width_option',
					//'label' => 'Full width?',
					'type' => 'checkbox',
					'description' => __('Set the 100% width of the row and content.', 'wpleadpages'),
					'options' => array(
		 			 
						'yes' => 'Full width'
					),
				),
				array(
					'name' => 'full_width',
					'label' => 'Stretch Option',
					'type' => 'radio',
					'value' => 'stretch_row',
					'description' => __('Please select stretch options.', 'wpleadpages'),
					'options' => array(
						'stretch_row' => 'Only Row',
						'stretch_row_content' => 'Row & Content'
					),
					'relation' => array(
						'parent' => 'full_width_option',
						'show_when' => 'yes'
					),
				),
				array(
					'name' => 'full_height',
					//'label' => __( 'Full height?', 'wpleadpages' ),
					'type' => 'checkbox',
					'description' => __( 'Set the 100% height of the row.', 'wpleadpages' ),
					'options' => array(
						'yes' => __( 'Full height', 'wpleadpages' )
					)
				),
				array(
					'name' => 'equal_height',
					//'label' => __( 'Equal height?', 'wpleadpages' ),
					'type' => 'checkbox',
					'description' => __( 'If checked, all columns will be set to equal height(not of row inner).', 'wpleadpages' ),
					'options' => array(
						'yes' => __( 'Equal height', 'wpleadpages' )
					)
				),
				array(
					'name' => 'content_placement',
					'label' => __( 'Content position', 'wpleadpages' ),
					'type' => 'select',
					'options' => array(
						'middle' => __( 'Middle', 'wpleadpages' ),
						'top' => __( 'Top', 'wpleadpages' ),
					),
					'description' => __( 'Select content position within row when full-height.', 'wpleadpages' ),
					'relation' => array(
						'parent' => 'full_height',
						'show_when' => 'yes'
					),
				),
				array(
					'name' => 'video_bg',
					//'label' => __( 'Use video background?', 'wpleadpages' ),
					'type' => 'checkbox',
					'description' => __( 'Add a Background video to this row.', 'wpleadpages' ),
					'options' => array( 'yes' => __( 'Video background', 'wpleadpages' ) )
				),
				array(
					'name' => 'video_bg_url',
					'label' => __( 'YouTube link', 'wpleadpages' ),
					'type' => 'text',
					'value' => 'https://www.youtube.com/watch?v=dOWFVKb2JqM',
					'description' => __( 'Add YouTube link.', 'wpleadpages' ),
					'relation' => array(
						'parent' => 'video_bg',
						'show_when' => 'yes'
					),
				),
				array(
					'name' => 'parallax',
					'label' => __( 'Parallax', 'wpleadpages' ),
					'type' => 'select',
					'options' => array(
						'' => __( 'None', 'wpleadpages' ),
						'yes' => __( 'Use Background Image', 'wpleadpages' ),
						'yes-new' => __( 'Upload New Image', 'wpleadpages' ),
					),
					'description' => __( 'Add a parallax scrolling to the row.', 'wpleadpages' ),
					'relation' => array(
						'parent' => 'video_bg',
						'hide_when' => 'yes',
					),
				),
				array(
					'name' => 'parallax_image',
					'label' => __( 'Image', 'wpleadpages' ),
					'type' => 'attach_images',
					'value' => '',
					'description' => __( 'Select image from media library.', 'wpleadpages' ),
					'relation' => array(
						'parent' => 'parallax',
						'show_when' => 'yes-new',
					),
				),
				array(
					'name' => 'parallax_speed',
					'label' => __( 'Parallax Speed', 'wpleadpages' ),
					'type' => 'select',
					'description' => __( 'Set speed of parallax when scroll.', 'wpleadpages' ),
					'options' => array(
						'1' => '1',
						'0.7' => '0.7',
						'0.4' => '0.4',
						'0.1' => '0.1',
					),
					'value' => '1',
					'relation' => array(
						'parent' => 'parallax',
						'show_when' => 'yes,yes-new',
					),
				),
				array(
					'name' => 'parallax_background_size',
					//'label' => __( 'Full background?', 'wpleadpages' ),
					'type' => 'checkbox',
					'description' => __( 'Make background size full width & height and prevent repeat', 'wpleadpages' ),
					'options' => array(
						'yes' => __( 'Full background', 'wpleadpages' ),
					),
					'value' => 'yes',
					'relation' => array(
						'parent' => 'parallax',
						'show_when' => 'yes,yes-new',
					),
				),
				/*array(
					'name' => 'use_container',
					//'label' => __( 'Row container', 'wpleadpages' ),
					'type' => 'checkbox',
					'options' => array(
						'yes' => __( 'Row container', 'wpleadpages' ),
					),
					'description' => __( 'Enable container for this row.', 'wpleadpages' )
				),
				array(
					'name' => 'container_class',
					'label' => __( 'Container extra classes name', 'wpleadpages' ),
					'type' => 'text',
					'description' => __( 'Add classes custom to the Container.', 'wpleadpages' ),
					'relation' => array(
						'parent' => 'use_container',
						'show_when' => 'yes',
					),
				),
				array(
					'name' => 'row_class',
					'label' => __( 'Row extra classes name', 'wpleadpages' ),
					'type' => 'text',
					'description' => __( 'Add additional custom classes to the Row.', 'wpleadpages' ),
				)*/
			)
		),


		'wlp_row_inner' => array(
			'name' => 'Inner row',
			'description' => 'Inner nested rows',
			'icon' => 'wlp-icon-row',
			'category' => '',
			'title' => 'Row Inner Settings',
			'is_container' => true,
			'css_box' => true,
			'live_editor' => $live_tmpl.'wlp_row_inner.php',
			'params' => array(
				/*array(
					'name' => 'row_id',
					'label' => 'Row ID',
					'type' => 'text',
					'value' => __('', 'wpleadpages'),
					'description' => 'The unique identifier of the row'
				),*/
				array(
					'name' => 'equal_height',
					//'label' => __( 'Equal height?', 'wpleadpages' ),
					'type' => 'checkbox',
					'description' => __( 'If checked, all columns will be set to equal height.', 'wpleadpages' ),
					'options' => array(
						'yes' => __( 'Equal height', 'wpleadpages' )
					)
				),
				/*array(
					'name' => 'row_class',
					'label' => __( 'Extra classes name', 'wpleadpages' ),
					'type' => 'text',
					'description' => __( 'If you wish to style a particular content element differently, please add a class name to this field and refer to it in your custom CSS.', 'wpleadpages' ),
				),
				array(
					'name' => 'row_class_container',
					'label' => __( 'Extra container classes', 'wpleadpages' ),
					'type' => 'text',
					'description' => __( 'Add additional classes name to the container in a row.', 'wpleadpages' ),
				),*/
			)
		),

		'wlp_column' => array(
			'name' => 'Column',
			'category' => '',
			'title' => 'Column Settings',
			'is_container' => true,
			'system_only' => true,
			'css_box' => true,
			'tab_icons' => array(
				'general' => 'et-tools',
				'responsive' => 'et-mobile'
			),
			'live_editor' => $live_tmpl.'wlp_column.php',
			'params' => array(
				 'general' => array(

					array(
						'name' => 'mailcol_class',
						'label' => __( 'Extra class name', 'wpleadpages' ),
						'type' => 'text',
						'description' => __( 'If you wish to style a particular content element differently, please add a class name to this field and refer to it in your custom CSS file.', 'wpleadpages' )
					),
					
				),
				'responsive' => $responsive
			)
		),

		'wlp_column_inner' => array(
			'name' => 'Column Inner',
			'category' => '',
			'title' => 'Column Inner Settings',
			'is_container' => true,
			'system_only' => true,
			'css_box' => true,
			'tab_icons' => array(
				'general' => 'et-tools',
				'responsive' => 'et-mobile'
			),
			'live_editor' => $live_tmpl.'wlp_column_inner.php',
			'params' => array(
				'general' => array(

					array(
						'name' => 'col_in_class',
						'label' => __( 'Extra class name', 'wpleadpages' ),
						'type' => 'text',
						'description' => __( 'If you wish to style a particular content element differently, please add a class name to this field and refer to it in your custom CSS file.', 'wpleadpages' )
					),
					/* array(
						'name' => 'col_in_class_container',
						'label' => __( 'Extra container Class', 'wpleadpages' ),
						'type' => 'text',
						'description' => __( 'Add class name for container into column.', 'wpleadpages' ),
					), */
				),
				'responsive' => $responsive
			)
		),

		 /*'wlp_box' => array(
			'name' => 'or Box',
			'category' => '',
			'title' => 'or Box Design',
			'icon' => 'wlp-icon-box',
			'pop_width' => 900,
			'description' => __( 'Helping design static block', 'wpleadpages' ),
			'live_editor' => $live_tmpl.'wlp_box.php',
			'params' => array(
				array(
					'name' => 'css_code',
					'type' => 'hidden',
				),
				array(
					'name' => 'data',
					'type' => 'wlp_box',
					'admin_label' => true,
					'value' => 'W3sidGFnIjoiZGl2IiwiY2hpbGRyZW4iOlt7InRhZyI6InRleHQiLCJjb250ZW50IjoiU2FtcGxlIFRleHQuIn1dfV0='
					/*This is special element, All will be built in template 
				),
			)
		),*/

		'wlp_tabs' => array(
			'name' => 'Tabs',
			'description' => __( 'Tabbed content section', 'wpleadpages' ),
			'category' => '',
			'icon' => 'wlp-icon-tabs',
			'title' => 'Tabs - Sliders Settings',
			'is_container' => true,
			'views' => array(
				'type' => 'views_sections',
				'sections' => 'wlp_tab'
			),
			'live_editor' => $live_tmpl.'wlp_tabs.php',
			'params' => array(
				/*array(
					'name' => 'class',
					'label' => 'Extra Class',
					'type' => 'text'
				),*/
				array(
					'name' => 'type',
					'label' => __('Layout style', 'wpleadpages'),
					'type' => 'select',
					'options' => array(
						'horizontal_tabs' => __('Horizontal Tabs', 'wpleadpages'),
						'vertical_tabs' => __('Vertical Tabs', 'wpleadpages'),
						'slider_tabs' => __('Owl Sliders', 'wpleadpages')
					),
					'description' => __('Set the design layout style of the tab.', 'wpleadpages')
				),
				array(
					'name' => 'title_slider',
					//'label' => 'Display Titles?',
					'type' => 'checkbox',
					'options' => array(
						'yes' => __('Display Titles', 'wpleadpages')
					),
					'relation' => array(
						'parent' => 'type',
						'show_when' => 'slider_tabs'
					),
					'description' => __('Display tabs title above of the slider', 'wpleadpages')
				),
				array(
					'name' => 'items',
					'label' => 'Number Items?',
					'type' => 'select',
					'options' => array(
						'1' => '1',
						'2' => '2',
						'3' => '3',
						'4' => '4',
						'5' => '5',
						'6' => '6',
					),
					'relation' => array(
						'parent' => 'type',
						'show_when' => 'slider_tabs'
					),
					'description' => __('Display number of items per each slide (Desktop Screen)', 'wpleadpages')
				),
				array(
					'name' => 'tablet',
					'label' => 'Items on tablet?',
					'type' => 'select',
					'options' => array(
						'1' => '1',
						'2' => '2',
						'3' => '3',
						'4' => '4',
						'5' => '5',
						'6' => '6',
					),
					'relation' => array(
						'parent' => 'type',
						'show_when' => 'slider_tabs'
					),
					'description' => __('Display number of items per each slide (Tablet Screen)', 'wpleadpages')
				),
				array(
					'name' => 'mobile',
					'label' => 'Items on smartphone?',
					'type' => 'select',
					'options' => array(
						'1' => '1',
						'2' => '2',
						'3' => '3',
						'4' => '4',
					),
					'relation' => array(
						'parent' => 'type',
						'show_when' => 'slider_tabs'
					),
					'description' => __('Display number of items per each slide (Smartphone Screen)', 'wpleadpages')
				),
				array(
					'name' => 'speed',
					'label' => 'Speed of slider',
					'type' => 'number_slider',
					'options' => array(
						'min' => 100,
						'max' => 1000,
						'show_input' => true
					),
					'value' => 450,
					'relation' => array(
						'parent' => 'type',
						'show_when' => 'slider_tabs'
					),
					'description' => __('The speed of sliders in millisecond', 'wpleadpages')
				),
				array(
					'name' => 'navigation',
					//'label' => 'Navigation',
					'type' => 'checkbox',
					'options' => array(
						'yes' => __('Navigation', 'wpleadpages')
					),
					'relation' => array(
						'parent' => 'type',
						'show_when' => 'slider_tabs'
					),
					'description' => __('Display the "Next" and "Prev" buttons.', 'wpleadpages')
				),
				array(
					'name' => 'pagination',
					//'label' => 'Pagination',
					'type' => 'checkbox',
					'options' => array(
						'yes' => __('Pagination', 'wpleadpages')
					),
					'relation' => array(
						'parent' => 'type',
						'show_when' => 'slider_tabs'
					),
					'value' => 'yes',
					'description' => __('Show the pagination.', 'wpleadpages')
				),
				array(
					'name' => 'autoplay',
					//'label' => 'Auto Play',
					'type' => 'checkbox',
					'options' => array(
						'yes' => __('Auto Play', 'wpleadpages')
					),
					'relation' => array(
						'parent' => 'type',
						'show_when' => 'slider_tabs'
					),
					'description' => __('The slider automatically plays when site loaded', 'wpleadpages')
				),
				array(
					'name' => 'autoheight',
					//'label' => 'Auto Height',
					'type' => 'checkbox',
					'options' => array(
						'yes' => __('Auto Height', 'wpleadpages')
					),
					'relation' => array(
						'parent' => 'type',
						'show_when' => 'slider_tabs'
					),
					'description' => __('The slider height will change automatically', 'wpleadpages')
				),
				array(
					'name' => 'effect_option',
					//'label' => 'Enable fadein effect?',
					'type' => 'checkbox',
					'options' => array(
						'yes' => __('Fadein effect', 'wpleadpages')
					),
					'relation' => array(
						'parent' => 'type',
						'hide_when' => 'slider_tabs'
					),
					'description' => __('Apply Fade in and out effects when tabs are clicked.', 'wpleadpages')
				),
				array(
					'name' => 'vertical_tabs_position',
					'label' => __('Position', 'wpleadpages'),
					'type' => 'select',
					'options' => array(
						'left' => __('Left', 'wpleadpages'),
						'right' => __('Right', 'wpleadpages')
					),
					'relation' => array(
						'parent' => 'type',
						'show_when' => array('vertical_tabs')
					),
					'description' => __('View tabs with at top or bottom', 'wpleadpages')
				),
				array(
					'name' => 'open_mouseover',
					//'label' => __('Open on mouseover', 'wpleadpages'),
					'type' => 'checkbox',
					'options' => array(
						'yes' => __( 'Show tab content on mouse over', 'wpleadpages' )
					),
					'relation' => array(
						'parent' => 'type',
						'hide_when' => 'slider_tabs'
					),
				),
				array(
					'name' => 'active_section',
					'label' => __('Default active section', 'wpleadpages'),
					'type' => 'text',
					'value' => '1',
					'relation' => array(
						'parent' => 'type',
						'hide_when' => 'slider_tabs'
					),
					'description' => __('Set default active tab section number.', 'wpleadpages')
				)
			),
			'content' => '[wlp_tab title="New Tab"][/wlp_tab]'
		),

		'wlp_tab' => array(
			'name' => 'Tab',
			'category' => '',
			'title' => 'Tab Settings',
			'is_container' => true,
			'system_only' => true,
			'live_editor' => $live_tmpl.'wlp_tab.php',
			'params' => array(
				array(
					'name' => 'title',
					'label' => 'Title',
					'type' => 'text',
					'value' => __('New Tab', 'wpleadpages'),
				),
				array(
					'name' => 'advanced',
					//'label' => 'Advance Title?',
					'type' => 'checkbox',
					'options' => array(
						'yes' => __('Advance Title', 'wpleadpages')
					),
					'description' => __('If you want more flexible options to display tab title', 'wpleadpages')
				),
				
				array(
					'name' => 'adv_title',
					'label' => 'Title Format',
					'type' => 'textarea',
					'value' => base64_encode( __('<p>New Tab<p>', 'wpleadpages') ),
					'relation' => array(
						'parent' => 'advanced',
						'show_when' => 'yes'
					),
					'description' => __('You can use short varibles {title}, {icon} , {icon_class}, {image}, {image_id}, {image_url}, {image_thumbnail}, {image_medium}, {image_large}, {image_full}, {tab_id}', 'wpleadpages')
				),
				array(
					'name' => 'adv_icon',
					'label' => 'Icon Title',
					'type' => 'icon_picker',
					'value' => '',
					'relation' => array(
						'parent' => 'advanced',
						'show_when' => 'yes'
					)
				),
				array(
					'name' => 'adv_image',
					'label' => 'Image Title',
					'type' => 'attach_image',
					'value' => '',
					'relation' => array(
						'parent' => 'advanced',
						'show_when' => 'yes'
					)
				),
				array(
					'name' => 'icon_option',
					//'label' => 'Use Icon?',
					'type' => 'checkbox',
					'options' => array(
						'yes' => __('Use Icon', 'wpleadpages')
					),
					'description' => __('If you want to display an icon beside title, Tick to choose an icon', 'wpleadpages'),
					'relation' => array(
						'parent' => 'advanced',
						'hide_when' => 'yes'
					)
				),
				array(
					'name' => 'icon',
					'label' => 'Icon Title',
					'type' => 'icon_picker',
					'value' => '',
					'description' => __('Choose an icon to display with title', 'wpleadpages'),
					'relation' => array(
						'parent' => 'icon_option',
						'show_when' => 'yes'
					)
				),
				/*array(
					'name' => 'class',
					'label' => 'Extra Class',
					'type' => 'text'
				)*/
			)
		),

		'wlp_accordion' => array(
			'name' => 'Accordion',
			'description' => __( 'Expandable content section', 'wpleadpages' ),
			'category' => '',
			'icon' => 'wlp-icon-accordion',
			'title' => 'Accordion Settings',
			'is_container' => true,
			'views' => array(
				'type' => 'views_sections',
				'sections' => 'wlp_accordion_tab',
				'display' => 'vertical'
			),
			'live_editor' => $live_tmpl.'wlp_accordion.php',
			'params' => array(
				array(
					'name' => 'title',
					'label' => 'Title',
					'type' => 'text',
					'description' => __('nter accordion title. The title appears on top of the contents.', 'wpleadpages')
				),
				array(
					'name' => 'open_all',
					//'label' => 'Collapse all?',
					'type' => 'checkbox',
					'options' => array(
						'yes' => __('Allow section collapse', 'wpleadpages')
					),
					'description' => __('Allow all accordion tabs to open', 'wpleadpages')
				),
				/*array(
					'name' => 'class',
					'label' => 'Extra class name',
					'type' => 'text',
					'description' => __('If you wish to style particular content element differently, please add a class name to this field and refer to it in your custom CSS file.', 'wpleadpages')
				)*/
			),
			'content' => '[wlp_accordion_tab title="Accordion Tab"][/wlp_accordion_tab]'
		),

		'wlp_accordion_tab' => array(
			'name' => 'Accordion Tab',
			'category' => '',
			'title' => 'Accordion Tab Settings',
			'is_container' => true,
			'system_only' => true,
			'live_editor' => $live_tmpl.'wlp_accordion_tab.php',
			'params' => array(
				array(
					'name' => 'title',
					'label' => __('Title', 'wpleadpages'),
					'value' => __('New Accordion Tab', 'wpleadpages'),
					'type' => 'text'
				),
				array(
					'name' => 'icon_option',
					//'label' => 'Use Icon?',
					'type' => 'checkbox',
					'options' => array(
						'yes' => __('Use Icon', 'wpleadpages')
					),
					'description' => __('If you want to display an icon beside title, Tick to choose an icon', 'wpleadpages')
				),
				array(
					'name' => 'icon',
					'label' => 'Icon Title',
					'type' => 'icon_picker',
					'value' => '',
					'description' => __('Choose an icon to display with title', 'wpleadpages'),
					'relation' => array(
						'parent' => 'icon_option',
						'show_when' => 'yes'
					)
				),
				/*array(
					'name' => 'class',
					'label' => 'Extra class name',
					'type' => 'text',
					'description' => __('', 'wpleadpages')
				)*/
			)
		),

		'wlp_column_text' => array(
			'name' => 'Text',
			'description' => __('Editable Text Block', 'wpleadpages'),
			'icon' => 'wlp-icon-text',
			'category' => '',
			'is_container' => true,
			'pop_width' => 440,
			'admin_view'	=> 'text',
			'preview_editable' => true,
			'live_editor' => $live_tmpl.'wlp_column_text.php',
			'params' => array(
				array(
					'name' => 'content',
					'label' => 'Content',
					'type' => 'textarea_html',
					'value' => 'Sample Text',
				),
				/*array(
					'name' => 'class',
					'label' => 'Extra Class',
					'type' => 'text',
				)*/
			)
		),

		'wlp_spacing' => array(
			'name' => 'Space',
			'description' => __('Empty space separator', 'wpleadpages'),
			'icon' => 'wlp-icon-spacing',
			'category' => '',
			'live_editor' => $live_tmpl.'wlp_spacing.php',
			'params' => array(
				array(
					'name' => 'height',
					'label' => 'Height',
					'type' => 'number_slider',
					'value' => '20',
					'options' => array(
						'min' => 0,
						'max' => 500,
						'unit' => 'px',
						'show_input' => true
					),
					'admin_label' => true,
					'description' => __('Set the size for spacing height', 'wpleadpages'),
				),
				/*array(
					'name' => 'class',
					'label' => __('Extra class name', 'wpleadpages'),
					'type' => 'text',
					'admin_label' => true,
					'description' => __('If you wish to style a particular content element differently, please add a class name to this field and refer to it in your custom CSS file.', 'wpleadpages')
				)*/
			)
		),

		'wlp_raw_code' => array(
			'name' => 'Custom Code',
			'description' => __('Custom HTML, CSS and Js Code', 'wpleadpages'),
			'icon' => 'wlp-icon-code',
			'category' => '',
			'pop_width' =>440,
			'live_editor' => $live_tmpl.'wlp_raw_code.php',
			'params' => array(
				array(
					'name' => 'code',
					'label' => 'Code',
					'type' => 'textarea',
					'value' => 'U2FtcGxlIENvZGU=',
					'admin_label' => true,
				)
			)
		),

		'wlp_single_image' => array(
			'name' => 'Single Image',
			'description' => __('Single image', 'wpleadpages'),
			'icon' => 'wlp-icon-image',
			'category' => '',
			'admin_view' => 'image',
			'preview_editable' => true,
			'css_box'	=> true,
			'live_editor' => $live_tmpl.'wlp_single_image.php',
			'params' => array(

				array(
					'name'    => 'image_source',
					'label'   => __('Image Source', 'wpleadpages'),
					'type'    => 'select',
					'options' => array(
						'media_library'  => __('Media library', 'wpleadpages'),
						'external_link'  => __('External link', 'wpleadpages'),
						'featured_image' => __('Featured Image', 'wpleadpages'),
					),
					'description' => __('Select image source.', 'wpleadpages')
				),
				array(
					'name'        => 'image',
					'label'       => 'Upload Image',
					'type'        => 'attach_image',
					'admin_label' => true,
					'relation'    => array(
						'parent'    => 'image_source',
						'show_when' => 'media_library'
					)
				),
				array(
					'name'     => 'image_external_link',
					'label'    => 'Image external link',
					'type'     => 'text',
					'relation' => array(
						'parent'    => 'image_source',
						'show_when' => 'external_link'
					),
					'description' => __('Enter external link.', 'wpleadpages')
				),
				array(
					'name'          => 'image_size',
					'label'         => 'Image Size',
					'type'          => 'select',
					'value'         => 'thumbnail',
					'relation'      => array(
						'parent'    => 'image_source',
						'show_when' => array('media_library', 'featured_image')
					),
					'options' => array(
						'thumbnail'  => __('Thumbnail', 'wpleadpages'),
						'medium'  => __('Medium', 'wpleadpages'),
						'large' => __('Large', 'wpleadpages'),
					),
					'description'   => __('Select image size', 'wpleadpages'),
					'value'         => 'large'
				),
				array(
					'name'          => 'image_size_el',
					'label'         => 'Image Size',
					'type'          => 'text',
					'relation'      => array(
						'parent'    => 'image_source',
						'show_when' => 'external_link'
					),
					'description'   => __('Enter the image size in pixels. Example: 200x100 (Width x Height).', 'wpleadpages')
				),
				array(
					'name'        => 'caption',
					'label'       => 'Caption',
					'type'        => 'text',
					'description' => __('Enter image caption.', 'wpleadpages')
				),
				array(
					'name'    => 'image_align',
					'label'   => 'Image alignment',
					'type'    => 'select',
					'options' => array(
						'left'   => __('Left', 'wpleadpages'),
						'right'  => __('Right', 'wpleadpages'),
						'center' => __('Center', 'wpleadpages')
					),
					'description' => __('Select image alignment.', 'wpleadpages')
				),
				array(
					'name'    => 'on_click_action',
					'label'   => __('On-click event', 'wpleadpages'),
					'type'    => 'select',
					'options' => array(
						''                 => __('None', 'wpleadpages'),
						'op_large_image'   => __('Link to large image', 'wpleadpages'),
						'lightbox'         => __('Open Image In Lightbox', 'wpleadpages'),
						'open_custom_link' => __('Open Custom Link', 'wpleadpages')
					),
					'description' => __('Set a click event when the image clicked.', 'wpleadpages')
				),
				array(
					'name'     => 'custom_link',
					'label'    => __('Custom Link', 'wpleadpages'),
					'type'     => 'text',
					'value'    => 'http://',
					'relation' => array(
						'parent'    => 'on_click_action',
						'show_when' => 'open_custom_link'
					),
					'description' => __('Enter URL if you want this image to have a link (Note: parameters like "mailto:" are also accepted).', 'wpleadpages')
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Image border radius', 'wpleadpages' ),
					'name'			=> 'image_border_r',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array(
						'min'	=> 0,
						'max'	=> 200,
						'unit' => 'px',
						'show_input'=> true
					),
					'value'			=> 0
				),
				/*array(
					'name'        => 'ieclass',
					'label'       => __('Image extra class', 'wpleadpages'),
					'type'        => 'text',
					'description' => __('Add class name for img tag.', 'wpleadpages')
				),
				array(
					'name'    => 'image_wrap',
					'label'   => 'Div Wrapper',
					'type'    => 'select',
					'options' => array(
						'yes'   => __('Yes, Please!', 'wpleadpages'),
						'no'   => __('No, Thanks!', 'wpleadpages')
					),
					'description' => __('Put the image into a div warpper', 'wpleadpages'),
					'value' => 'yes'
				),
				array(
					'name'        => 'class',
					'label'       => __('Wrapper extra class', 'wpleadpages'),
					'type'        => 'text',
					'description' => __('If you wish to style a particular content element differently, please add a class name to this field and refer to it in your custom CSS file.', 'wpleadpages'),
					'relation' => array(
						'parent' => 'image_wrap',
						'show_when' => 'yes'
					)
				)*/
			)
		),

		'wlp_icon' => array(
			'name'		  => 'Icon',
			'description' => __('Icon from Collections', 'wpleadpages'),
			'icon'		  => 'wlp-icon-icon',
			'category'	  => '',
			'live_editor' => $live_tmpl.'wlp_icon.php',
			'params'	  => array(
				array(
					'name'	      => 'icon',
					'label'	      => 'Select Icon',
					'type'	      => 'icon_picker',
					'admin_label' => true,
				),
				array(
					'name'	      => 'icon_align',
					'label'	      => 'Icon alignment',
					'type'	      => 'dropdown',
					'description' => __('', 'wpleadpages'),
					'options'     => array(
						'none'    => __('None', 'wpleadpages'),
						'left'    => __('Left', 'wpleadpages'),
						'right'   => __('Right', 'wpleadpages'),
						'center'  => __('Center', 'wpleadpages'),
					)
				),
				array(
				
					'type'			=> 'number_slider',
					'label'			=>  __( 'Icon Size', 'wpleadpages' ),
					'name'			=> 'icon_size',
					'description'	=> __('Enter icon font size. Example: 15px, 1em.', 'wpleadpages'),
					'value'			=> '10',
					'options' => array(
						'min' => 0,
						'max' => 100,
						'unit' => 'px',
						'show_input' => true
					)
				),
				array(
					'name'	      => 'icon_color',
					'label'	      => 'Icon Color',
					'type'	      => 'colwlp_picker',
					'admin_label' => true,
					'description' => __('Color of the icon.', 'wpleadpages')
				),
				/*array(
					'name'	      => 'class',
					'label'	      => __('Extra class name', 'wpleadpages'),
					'type'	      => 'text',
					'admin_label' => true,
					'description' => __('If you wish to style a particular content element differently, please add a class name to this field and refer to it in your custom CSS file.', 'wpleadpages')
				),
				array(
					'name'	      => 'icon_wrap',
					//'label'	      => 'Icon Wrapper?',
					'type'	      => 'checkbox',
					'options'	  => array(
						'yes'     => __('Icon Wrapper', 'wpleadpages')
					),
					'description' => __('Add a <div> tag around the icon.', 'wpleadpages')
				),
				array(
					'name'	        => 'icon_wrap_class',
					'label'	        => 'Wrapper class name',
					'type'	        => 'text',
					'description'   => __('Enter class name for wrapper', 'wpleadpages'),
					'relation'      => array(
						'parent'    => 'icon_wrap',
						'show_when' => 'yes'
					)
				),*/
			)
		),

		'wlp_title' => array(
			'name'		  => 'Title',
			'description' => __('Heading Text Blocks', 'wpleadpages'),
			'icon'		  => 'wlp-icon-title',
			'category'	  => '',
			'css_box'	  => true,
			'live_editor' => $live_tmpl.'wlp_title.php',
			'params'	  => array(
				array(
					'name'	      => 'text',
					'label'       => 'Text',
					'type'	      => 'textarea',
					'value'		  => base64_encode('The Title'),
					'admin_label' => true
				),
				array(
					'name'	  => 'type',
					'label'   => 'Type',
					'type'	  => 'select',
					'options' => array(
						'h1'  => 'H1',
						'h2'  => 'H2',
						'h3'  => 'H3',
						'h4'  => 'H4',
						'h5'  => 'H5',
						'h6'  => 'H6'
					)
				),
				array(
					'name'	  => 'align',
					'label'   => 'Align',
					'type'	  => 'select',
					'options' => array(
						''  => 'Normal',
						'left'  => 'Left',
						'center'  => 'Center',
						'right'  => 'Right'
					)
				),
				/*array(
					'name'	=> 'class',
					'label' => 'Extra Class',
					'type'	=> 'text'
				),*/
				/*array(
					'name'	      => 'title_wrap',
					//'label'       => 'Advanced',
					'type'	      => 'checkbox',
					'options'     => array(
						'yes'     => __('Advanced', 'wpleadpages')
					),
					'description' => __('Add a &lt;div&gt; tag around the head tag, more code before or after the head tag.', 'wpleadpages')
				),
				array(
					'name'	      => 'before',
					'label'       => 'Before Head Tag',
					'type'	      => 'textarea',
					'description' => __('Add HTML text before the head tag.', 'wpleadpages'),
					'relation'      => array(
						'parent'    => 'title_wrap',
						'show_when' => 'yes'
					)
				),
				array(
					'name'	      => 'after',
					'label'       => 'After Head Tag',
					'type'	      => 'textarea',
					'description' => __('Add HTML text after the head tag.', 'wpleadpages'),
					'relation'      => array(
						'parent'    => 'title_wrap',
						'show_when' => 'yes'
					)
				),
				 array(
					'name'	        => 'title_wrap_class',
					'label'         => 'Wrapper class name',
					'type'	        => 'text',
					'description'   => __('Enter class name for wrapper', 'wpleadpages'),
					'relation'      => array(
						'parent'    => 'title_wrap',
						'show_when' => 'yes'
					)
				)*/
			)
		),

		'wlp_google_maps' => array(

			'name'			   => __('Google Maps', 'wpleadpages'),
			'description'	   => __('Google Map Address Block', 'wpleadpages'),
			'icon'			   => 'wlp-icon-map',
			'category'		   => '',
			'admin_view'	   => 'gmaps',
			'live_editor' => $live_tmpl.'wlp_google_maps.php',
			'params'		   => array(
				array(
					'name'        => 'random_id',
					'label'       => '',
					'type'        => 'random',
					'description' => '',
				),
				array(
					'type'			=>  'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( "Map title. You can leave it blank if it's not needed", 'wpleadpages' ),
				),
				array(
					'type'			=> 'textarea',
					'label'			=> __( 'Map location iframe embed code:', 'wpleadpages' ),
					'name'			=> 'map_location',
					'value'			=> base64_encode( '<iframe src="https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d387190.2798864717!2d-74.25986673512958!3d40.69767006847739!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x89c24fa5d33f083b%3A0xc80b8f06e177fe62!2sNew+York%2C+NY%2C+USA!5e0!3m2!1sen!2sin!4v1466170833439" width="600" height="450" frameborder="0" style="border:0" allowfullscreen></iframe>'),
					'description'	=> __( 'Instruction: Go to Google Maps and search the for your location. Then click on the "Share" button, on the pop up that appears, click the "Embed map" tab and copy the iframe code.' )
				),
				array(
					'type'			 => 'number_slider',
					'label'			 => __( 'Map Height', 'wpleadpages' ),
					'name'			 => 'map_height',
					'description'	 => __( 'Set map height. Example: 300 px', 'wpleadpages' ),
					'value'			 => '350',
					'options'        => array(
						'min'        => 50,
						'max'        => 1000,
						'unit'       => 'px',
						'show_input' => true
					)
				),
				array(
					'type'			     => 'checkbox',
					//'label'			     => __( 'Show overlap contact form', 'wpleadpages' ),
					'name'			     => 'show_ocf',
					'description'	     => __( 'Display a contact form on the map', 'wpleadpages' ),
					'options'			 => array( 'yes' => __( 'Overlap contact form on the map', 'wpleadpages' ) )
				),
				array(
					'type'			     => 'textarea',
					'label'			     => __( 'Contact form shortcode', 'wpleadpages' ),
					'name'			     => 'contact_form_sc',
					'description'	     => __( 'Shortcode content which generated by contact form 7. For example: [contact-form-7 id="4" title="Contact form 1"]', 'wpleadpages' ),
					'relation'		     => array(
						'parent'         => 'show_ocf',
						'show_when'      => 'yes'
					)
				),
				array(
					'type'			 => 'text',
					'label'			 => __( 'Contact area width', 'wpleadpages' ),
					'name'			 => 'contact_area_width',
					'description'	 => __( 'Width of wrapper form. Ex: 45% or 400px', 'wpleadpages' ),
					'relation'		 => array(
						'parent'     => 'show_ocf',
						'show_when'  => 'yes'
					),
					'value'			 => '45%'
				),
				array(
					'type'			 => 'select',
					'label'			 => __( 'Contact area position', 'wpleadpages' ),
					'name'			 => 'contact_area_position',
					'options'		 => array(
						'left'  => __( 'Left', 'wpleadpages' ),
						'right' => __( 'Right', 'wpleadpages' ),
					),
					'description'	=> __( 'Set position for the contact form box', 'wpleadpages' ),
					'relation'		=> array(
						'parent' => 'show_ocf',
						'show_when' => 'yes'
					),
					'value'			=> 'left'
				),
				/*array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Contact area background', 'wpleadpages' ),
					'name'			=> 'contact_area_bg',
					'description'	=> __( 'Set background color for the contact form', 'wpleadpages' ),
					'relation'		=> array(
						'parent' => 'show_ocf',
						'show_when' => 'yes'
					),
					'value' 		=> '#a1aee2'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Contact form color', 'wpleadpages' ),
					'name'			=> 'contact_form_color',
					'description'	=> __( 'Set color for text in contact form', 'wpleadpages' ),
					'relation'		=> array(
						'parent' => 'show_ocf',
						'show_when' => 'yes'
					),
					'value' 		=> '#3c3c3c'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Submit button color', 'wpleadpages' ),
					'name'			=> 'submit_button_color',
					'description'	=> __( '', 'wpleadpages' ),
					'relation'		=> array(
						'parent' => 'show_ocf',
						'show_when' => 'yes'
					),
					'value' 		=> '#393939'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Submit button hover color', 'wpleadpages' ),
					'name'			=> 'submit_button_hover_color',
					'description'	=> __( '', 'wpleadpages' ),
					'relation'		=> array(
						'parent' => 'show_ocf',
						'show_when' => 'yes'
					),
					'value' 		=> '#575757'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Submit button text color', 'wpleadpages' ),
					'name'			=> 'submit_button_text_color',
					'description'	=> __( '', 'wpleadpages' ),
					'relation'		=> array(
						'parent' => 'show_ocf',
						'show_when' => 'yes'
					),
					'value' 		=> '#FFFFFF'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Submit button text hover color', 'wpleadpages' ),
					'name'			=> 'submit_button_text_hover_color',
					'description'	=> __( '', 'wpleadpages' ),
					'relation'		=> array(
						'parent' => 'show_ocf',
						'show_when' => 'yes'
					),
					'value' 		=> '#FFFFFF'
				),
				array(
					'type'			=>  'text',
					'label'			=> __( 'Wrapper class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
				),*/
			)
		),

		'wlp_twitter_feed' => array(
			'name'			=> __('Twitter Feed', 'wpleadpages'),
			'description'	=> __('Twitter News Feed', 'wpleadpages'),
			'icon' => 'wlp-icon-twitter',
			'category' => '',
			'css_box' => true,
			'params' => array(
				array(
					'type'			=>  'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( "Widget title. You can leave it blank if it's not needed.", 'wpleadpages' ),
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Twitter username', 'wpleadpages' ),
					'name'			=> 'username',
					'value'			=> 'OriginBuilder',
					'admin_label'	=> true
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Layout style', 'wpleadpages' ),
					'name'			=> 'display_style',
					'options'			=> array(
						'1' => __( 'List View', 'wpleadpages' ),
						'2' => __( 'Slider tweets', 'wpleadpages' ),
					),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Twitter box height', 'wpleadpages' ),
					'name'			=> 'max_height',
					//'description'	=> __( 'Set the height of the Twitter feed box, from 100px to 800px. Scroll bar will appear if the Twitter feed box height is bigger than the one you set. Enter “0” to show all tweets you set without scroll bar. Min:100px, max: 800px', 'wpleadpages' ),
					'value'			=> '350',
					'options'		=> array(
						'min' => 100,
						'max' => 800,
						'unit' => 'px',
						'show_input' => true
					),
					'relation' 		=> array(
						'parent'	=> 'display_style',
						'show_when' => '1'
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show navigation', 'wpleadpages' ),
					'name'			=> 'show_navigation',
					'options'		=> array( 'yes' => __( 'Show navigation', 'wpleadpages' ) ),
					'value'			=> 'yes',
					'relation'		=> array(
						'parent'	=> 'display_style',
						'show_when'	=> '2'
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show pagination', 'wpleadpages' ),
					'name'			=> 'show_pagination',
					'options'		=> array( 'yes' => __( 'Show pagination', 'wpleadpages' ) ),
					'value'			=> 'yes',
					'relation'		=> array(
						'parent'	=> 'display_style',
						'show_when'	=> '2'
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Auto height', 'wpleadpages' ),
					'name'			=> 'auto_height',
					'options'		=> array( 'yes' => __( 'Auto height', 'wpleadpages' ) ),
					'relation'		=> array(
						'parent'	=> 'display_style',
						'show_when'	=> '2'
					)
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Number of Tweets to display', 'wpleadpages' ),
					'name'			=> 'number_tweet',
					'admin_label'	=> true,
					'value'			=> '5',
					'options' 		=> array(
						'min' => 1,
						'max' => 20,
						'show_input' => true
					)
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Link color', 'wpleadpages' ),
					'name'			=> 'link_color',
					'description'	=> __( 'Color for the links on box.', 'wpleadpages' ),
					'value'			=> '#f7d377'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Link hover color:', 'wpleadpages' ),
					'name'			=> 'link_colwlp_hover',
					'description'	=> __( 'Hover color for links on box.', 'wpleadpages' ),
					 
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show Time', 'wpleadpages' ),
					'name'			=> 'show_time',
					'description'	=> __( 'Show how much time has elapsed since a tweet was posted: Example: "10m ago"', 'wpleadpages' ),
					'options'		=> array( 'yes' => __( 'Show Time', 'wpleadpages' ) ),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'checkbox',
				//	'label'			=> __( 'Show reply link', 'wpleadpages' ),
					'name'			=> 'show_reply',
					'description'	=> __( 'Show Reply link to each tweet.', 'wpleadpages' ),
					'options'		=> array( 'yes' => __( 'Show reply link', 'wpleadpages' ) ),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Allow Retweet', 'wpleadpages' ),
					'name'			=> 'show_retweet',
					'description'	=> __( 'Show Retweet link to each tweet.', 'wpleadpages' ),
					'options'		=> array( 'yes' => __( 'Allow Retweet', 'wpleadpages' ) ),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show Twitter avatar', 'wpleadpages' ),
					'name'			=> 'show_avatar',
					'description'	=> __( 'Show avatar of Twitter account beside each tweet.', 'wpleadpages' ),
					'options'		=> array( 'yes' => __( 'Show Twitter avatar', 'wpleadpages' ) ),
					'relation' 		=> array(
						'parent'	=> 'display_style',
						'show_when' => '1'
					),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show Follow button', 'wpleadpages' ),
					'name'			=> 'show_follow_button',
					'options'		=> array( 'yes' => __( 'Show Follow button', 'wpleadpages' ) ),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Use Own API Key', 'wpleadpages' ),
					'name'			=> 'use_api_key',
					'options'		=> array( 'yes' => __( 'Use Own API Key', 'wpleadpages' ) )
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Consumer Key (API Key)', 'wpleadpages' ),
					'name'			=> 'consumer_key',
					'value'			=> '',
					'relation'		=> array(
						'parent' => 'use_api_key',
						'show_when' => 'yes'
					)
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Consumer Secret (API Secret)', 'wpleadpages' ),
					'name'			=> 'consumer_secret',
					'value'			=> '',
					'relation'		=> array(
						'parent' => 'use_api_key',
						'show_when' => 'yes'
					)
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Access Token', 'wpleadpages' ),
					'name'			=> 'access_token',
					'value'			=> '',
					'relation'		=> array(
						'parent' => 'use_api_key',
						'show_when' => 'yes'
					)
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Access Token Secret', 'wpleadpages' ),
					'name'			=> 'access_token_secrect',
					'value'			=> '',
					'relation'		=> array(
						'parent' => 'use_api_key',
						'show_when' => 'yes'
					)
				),
				/*array(
					'type'			=> 'text',
					'label'			=> __( 'Wrapper class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
					'value'			=> ''
				)*/
			)
		),

		/* Just for test icon
		---------------------------------------------------------- */

		'wlp_instagram_feed' => array(

			'name' => __('Instagram Feed', 'wpleadpages'),
			'description' => __('Instagram Feed', 'wpleadpages'),
			'icon' => 'wlp-icon-instagram',
			'category' => '',
			'css_box' => true,
			'params' => array(
				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( "Widget title. You can leave it blank if it's not needed", 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Number of photos', 'wpleadpages' ),
					'name'			=> 'number_show',
					'description'	=> __( 'Set the number of photos to display.', 'wpleadpages' ),
					'value'			=> '8',
					'options' => array(
						'min' => 1,
						'max' => 16,
						'show_input' => true
					),
					'admin_label'	=> true,
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Number of Columns', 'wpleadpages' ),
					'name'			=> 'columns_style',
					'options'			=> array(
						'1' => __( '1 Columns', 'wpleadpages' ),
						'2' => __( '2 Columns', 'wpleadpages' ),
						'3' => __( '3 Columns', 'wpleadpages' ),
						'4' => __( '4 Columns', 'wpleadpages' ),
						'5' => __( '5 Columns', 'wpleadpages' ),
						'6' => __( '6 Columns', 'wpleadpages' )
					),
					'description'	=> __( 'Set the photo columns.', 'wpleadpages' ),
					'value'			=> '4'
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Image Size', 'wpleadpages' ),
					'name'			=> 'image_size',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array(
						'low_resolution' => 'Low resolution',
						'thumbnail' => 'Thumbnail',
						'standard_resolution' => 'Standard resolution',
					)
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Instagram username:', 'wpleadpages' ),
					'name'			=> 'username',
					'description'	=> __( 'Enter your Instagram username.', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Access token', 'wpleadpages' ),
					'name'			=> 'access_token',
					'description'	=> __( 'You can generate your Access Token at http://instagram.pixelunion.net/', 'wpleadpages' ),
					'value'			=> ''
				),
				/*array(
					'type'			=> 'text',
					'label'			=> __( 'Custom class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
				)*/
			)

		),

		'wlp_fb_recent_post' => array(

			'name' => __('FaceBook Post', 'wpleadpages'),
			'description' => __('Facebook Newsfeed Post', 'wpleadpages'),
			'icon' => 'wlp-icon-facebook',
			'category' => '',
			//'css_box' => true,
			'params' => array(
				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( "Widget title. You can leave it blank if it's not needed", 'wpleadpages' ),
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Facebook Page slug', 'wpleadpages' ),
					'name'			=> 'fb_page_id',
					'description'	=> __( 'Facebook page ID or slug. For example: wordpress', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Facebook App ID', 'wpleadpages' ),
					'name'			=> 'fb_app_id',
					'description'	=> __( 'Create and get your App ID at https://developers.facebook.com/apps', 'wpleadpages' ),
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Facebook App Secret', 'wpleadpages' ),
					'name'			=> 'fb_app_secret',
					'description'	=> __( 'Get your App Secret from https://developers.facebook.com/apps', 'wpleadpages' ),
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Facebook feed height', 'wpleadpages' ),
					'name'			=> 'max_height',
					'description'	=> __( 'Set the height of Facebook feed box.' ),
					'value'			=> '350',
					'options' => array(
						'min' => 50,
						'max' => 1000,
						'unit' => 'px',
						'show_input' => true
					)
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Number of posts to display', 'wpleadpages' ),
					'name'			=> 'number_post_show',
					'description'	=> __( 'The number of posts displayed', 'wpleadpages' ),
					'value'			=> '5',
					'admin_label'	=> true,
					'options' => array(
						'min' => 1,
						'max' => 10,
						'show_input' => true
					)
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Number of words per post', 'wpleadpages' ),
					'name'			=> 'number_of_des',
					'description'	=> __( 'The number of words in each facebook post, for example: 25.' ),
					'value'			=> '25'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show Image?', 'wpleadpages' ),
					'name'			=> 'show_image',
					'description'	=> __( 'Show the featured image of the Facebook post.', 'wpleadpages' ),
					'options'		=> array( 'yes' => __( 'Show Image', 'wpleadpages' ) ),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show Like Count?', 'wpleadpages' ),
					'name'			=> 'show_like_count',
					'description'	=> __( 'Show the Like count link in the Facebook post.', 'wpleadpages' ),
					'options'		=> array( 'yes' => __( 'Show Like Count', 'wpleadpages' ) ),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show Comment Count?', 'wpleadpages' ),
					'name'			=> 'show_comment_count',
					'description'	=> __( 'Show Comment count link in the Facebook post.', 'wpleadpages' ),
					'options'		=> array( 'yes' => __( 'Show Comment Count', 'wpleadpages' ) ),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show Time', 'wpleadpages' ),
					'name'			=> 'show_time',
					'description'	=> __( 'Show how long it was since a post was published.', 'wpleadpages' ),
					'options'		=> array( 'yes' => __( 'Show Time', 'wpleadpages' ) ),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Open URL in a new tab', 'wpleadpages' ),
					'name'			=> 'open_link_new_window',
					'description'	=> __( 'All Facebook URLs will open in a new tab.', 'wpleadpages' ),
					'options'		=> array( 'yes' => __( 'Open URL in a new tab', 'wpleadpages' ) ),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show profile button', 'wpleadpages' ),
					'name'			=> 'show_profile_button',
					'description'	=> __( 'Show the profile button underneath the Facebook post box.', 'wpleadpages' ),
					'options'		=> array( 'yes' => __( 'Show profile button', 'wpleadpages' ) ),
				),
				/*array(
					'type'			=> 'text',
					'label'			=> __( 'Custom class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
				)*/
			)

		),

		/*'wlp_flip_box' => array(
			'name' => __('Flip Box', 'wpleadpages'),
			'description' => __('', 'wpleadpages'),
			'icon' => 'wlp-icon-flip',
			'category' => '',
			'css_box' => true,
			'live_editor' => $live_tmpl.'wlp_flip_box.php',
			'params' => array(

				array(
					'type'			=> 'attach_image',
					'label'			=> __( 'Front Image', 'wpleadpages' ),
					'name'			=> 'image',
					'description'	=> __( 'Upload image for the front side.', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Image size', 'wpleadpages' ),
					'name'			=> 'image_size',
					'description'	=> __( 'Set the image size (For example: thumbnail, medium, large or full).', 'wpleadpages' ),
					'admin_label'	=> true,
					'value'			=> 'full'
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( 'Title of the FlipBox. Leave blank if no title is needed.', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'textarea',
					'label'			=> __( 'Description', 'wpleadpages' ),
					'name'			=> 'description',
					'description'	=> __( 'Enter description for the back side, Shortcode are supported in this field.', 'wpleadpages' )
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Direction', 'wpleadpages' ),
					'name'			=> 'direction',
					'options'		=> array(
						'horizontal' => __( 'Horizontal', 'wpleadpages' ),
						'vertical' => __( 'Vertical', 'wpleadpages' ),
					),
					'description'	=> __( 'Direction of flip', 'wpleadpages' ),
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Text align', 'wpleadpages' ),
					'name'			=> 'text_align',
					'options'		=> array(
						'center' => __( 'Center', 'wpleadpages' ),
						'left' => __( 'Left', 'wpleadpages' ),
						'right' => __( 'Right', 'wpleadpages' ),
						'justtify' => __( 'Justtify', 'wpleadpages' ),
					),
					'description'	=> __( 'Set the text align: Center, left, right or justtify', 'wpleadpages' ),
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Text Color', 'wpleadpages' ),
					'name'			=> 'text_color',
					'description'	=> __( 'Color of the text.', 'wpleadpages' ),
					'value'			=> '#FFFFFF'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Background Back side', 'wpleadpages' ),
					'name'			=> 'bg_backside',
					'description'	=> __( 'Background color of the back side.', 'wpleadpages' ),
					'value'			=> '#393939'
				),
				array(
					'type'			=> 'checkbox',
					'label'			=> __( 'Show button', 'wpleadpages' ),
					'name'			=> 'show_button',
					'description'	=> __( 'Show the button in the back side.', 'wpleadpages' ),
					'options'			=> array( 'yes' => __( 'Yes, Please', 'wpleadpages' ) ),
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Text on button', 'wpleadpages' ),
					'name'			=> 'text_on_button',
					'description'	=> __( 'Set the text displayed on the button.', 'wpleadpages' ),
					'relation'	=> array(
						'parent' => 'show_button',
						'show_when' => 'yes'
					),
					'value'			=> 'Read more'
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'URL', 'wpleadpages' ),
					'name'			=> 'link',
					'description'	=> __( 'URL of the button in the back side.', 'wpleadpages' ),
					'value'			=> '#',
					'relation'	=> array(
						'parent' => 'show_button',
						'show_when' => 'yes'
					)
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Button text color', 'wpleadpages' ),
					'name'			=> 'text_button_color',
					'description'	=> __( 'Color of the button text.', 'wpleadpages' ),
					'relation'	=> array(
						'parent' => 'show_button',
						'show_when' => 'yes'
					),
					'value'			=> '#FFFFFF'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Button background color', 'wpleadpages' ),
					'name'			=> 'button_bg_color',
					'description'	=> __( 'Background color of the button. (Default values is: transparent)', 'wpleadpages' ),
					'relation'	=> array(
						'parent' => 'show_button',
						'show_when' => 'yes'
					),
					'value'			=> 'transparent'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Button background color on hover', 'wpleadpages' ),
					'name'			=> 'button_bg_hover_color',
					'description'	=> __( 'Button\'s background color that changes when the mouse cursor hovers over it.', 'wpleadpages' ),
					'relation'	=> array(
						'parent' => 'show_button',
						'show_when' => 'yes'
					),
					'value'			=> '#FFFFFF'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Button text color on hover', 'wpleadpages' ),
					'name'			=> 'text_button_colwlp_hover',
					'description'	=> __( 'Button text color that changes when the mouse cursor hovers over it.', 'wpleadpages' ),
					'relation'	=> array(
						'parent' => 'show_button',
						'show_when' => 'yes'
					),
					'value'			=> '#86c724'
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Wrapper class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
					'value'			=> ''
				)
			)

		),*/

		'wlp_pie_chart' => array(
			'name' => __('Pie Chart', 'wpleadpages'),
			'description' => __('Animated pie chart', 'wpleadpages'),
			'icon' => 'wlp-icon-pie',
			'category' => '',
			'css_box' => true,
			'live_editor' => $live_tmpl.'wlp_pie_chart.php',
			'params'		=> array(
                	array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( 'Title of the Pie chart.', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'textarea',
					'label'			=> __( 'Description', 'wpleadpages' ),
					'name'			=> 'description',
					'description'	=> __( 'Enter the chart description.', 'wpleadpages' ),
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Percentage Value', 'wpleadpages' ),
					'name'			=> 'percent',
					'description'	=> __( 'Enter the chart description.', 'wpleadpages' ),
					'admin_label'	=> true,
					'value' 		=> '50',
					'options'		=> array(
						'unit'		=> '%',
						'show_input'=> true
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Rounded corners', 'wpleadpages' ),
					'name'			=> 'rounded_corners_bar',
					'description'	=> __( 'Have the percentage bar withrounded edges.', 'wpleadpages' ),
					'options'		=> array( 'yes' => __( 'Rounded corners', 'wpleadpages' ) ),
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Pie Size', 'wpleadpages' ),
					'name'			=> 'size',
					'description'	=> __( 'Pie size (diameter).', 'wpleadpages' ),
					'options'			=> array(
						'100' 		=> __('100 px', 'wpleadpages'),
						'150' 		=> __('150 px', 'wpleadpages'),
						'200' 		=> __('200 px', 'wpleadpages'),
						'custom' 	=> __('Custom', 'wpleadpages'),
						'auto'		=> __( 'Auto width', 'wpleadpages' )
					)
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Custom size', 'wpleadpages' ),
					'name'			=> 'custom_size',
					'description'	=> __( 'It is width and height of pie chart, unit (px).', 'wpleadpages' ),
					'admin_label'	=> true,
					'relation' 	=> array(
						'parent' 	=> 'size',
						'show_when' => 'custom'
					),
					'options'		=> array(
						'show_input'=> true,
						'min'	=> 50,
						'max'	=> 500
					),
					'value'			=> '120'
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Line Width', 'wpleadpages' ),
					'name'			=> 'linewidth',
					'description'	=> __( 'Drag slider to change the Width of the line in px.', 'wpleadpages' ),
					'admin_label'	=> true,
					'value' 		=> '10',
					'options'		=> array(
						'show_input'=> false,
						'min'	=> 1,
						'max'	=> 30,
						'show_input' => true
					)
				),
			

				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Bar Color', 'wpleadpages' ),
					'name'			=> 'barcolor',
					'description'	=> __( 'Color of the percentage bar.', 'wpleadpages' ),
					'value'			=> '#39c14f'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Track Color', 'wpleadpages' ),
					'name'			=> 'trackcolor',
					'description'	=> __( 'Color of the track pie.', 'wpleadpages' ),
					'value'			=> '#e4e4e4'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Label color', 'wpleadpages' ),
					'name'			=> 'label_color',
					'description'	=> __( 'Color of the percentage bar number.', 'wpleadpages' ),
					'value'			=> '#FF5252'
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Label front size', 'wpleadpages' ),
					'name'			=> 'label_font_size',
					'description'	=> __( 'Font size of the percentage value', 'wpleadpages' ),
					'value'			=> '20',
					'options'		=> array(
						'unit'		=> 'px',
						'show_input'=> true
					)
				),
				/*array(
					'type'			=> 'text',
					'label'			=> __( 'Wrapper class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
				)*/
			)

		),
		'wlp_progress_bars' => array(

			'name' => __('Progress Bar', 'wpleadpages'),
			'description' => __('Animated progress bar', 'wpleadpages'),
			'icon' => 'wlp-icon-progress',
			'category' => '',
			'css_box' => true,
			'live_editor' => $live_tmpl.'wlp_progress_bars.php',
			'params' => array(

				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( 'Enter the title of the progress bar. If no title is required, leave blank.', 'wpleadpages' ),
					'admin_label'	=> true,
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Style', 'wpleadpages' ),
					'name'			=> 'style',
					'description'	=> __( 'Select the style of progress bars.', 'wpleadpages' ),
					'options'		=> array(
						'1' => __('Style 1', 'wpleadpages'),
						'2' => __('Style 2 (Value in tooltip)', 'wpleadpages'),
						'3' => __('Style 3 (Value in progress bar)', 'wpleadpages')
					),
					'admin_label'	=> true,
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Border radius', 'wpleadpages' ),
					'name'			=> 'radius',
					'description'	=> __( 'Set Border radius for bars', 'wpleadpages' ),
					'options'			=> array( 'yes' => __( 'Border radius', 'wpleadpages' ) ),
					'value' 			=> 'no'
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Processbar Weight', 'wpleadpages' ),
					'name'			=> 'weight',
					'description'	=> __( 'Height weight of progress bar: Ex 12, unit (px)', 'wpleadpages' ),
					'value'			=> '12',
					'options' 		=> array(
						'min'		=> 2,
						'max'		=> 40,
						'show_input'=> true,
					)
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Spacing', 'wpleadpages' ),
					'name'			=> 'margin',
					'description'	=> __( 'The spacing between items', 'wpleadpages' ),
					'value'			=> '20',
					'options' 		=> array(
						'min'		=> 0,
						'max'		=> 100,
						'show_input'=> true,
					),
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Animate Speed', 'wpleadpages' ),
					'name'			=> 'speed',
					'description'	=> __( 'Select animation speed.', 'wpleadpages' ),
					'options'		=> array(
						'2000' => __('Normal', 'wpleadpages'),
						'1600' => __('Fast', 'wpleadpages'),
						'1200' => __('Very Fast', 'wpleadpages'),
						'2400' => __('Slow', 'wpleadpages'),
						'2800' => __('Very Slow', 'wpleadpages'),
					),
					'value'			=> '2000',
					'admin_label'	=> true,
				),
				array(
					'type'			=> 'group',
					'label'			=> __('Options', 'wpleadpages'),
					'name'			=> 'options',
					//'description'	=> __( 'Repeat this fields with each item created, Each item corresponding processbar element.', 'wpleadpages' ),
					'value' => base64_encode( json_encode(array(
						"1" => array(
							"value" => "90",
							"value_color" => "#999999",
							"label" => "Development",
							"label_color" => "#0d6347",
							"prob_color" => "#1a6c9c",
							"prob_bg_color" => "#dbdbdb"
						),
						"2" => array(
							"value" => "80",
							"value_color" => "#626a0d",
							"label" => "Design",
							"label_color" => "#0d6347",
							"prob_color" => "#1a6c9c",
							"prob_bg_color" => "#dbdbdb"
						),
						"3" => array(
							"value" => "70",
							"value_color" => "#6b1807",
							"label" => "Marketing",
							"label_color" => "#0d6347",
							"prob_color" => "#1a6c9c",
							"prob_bg_color" => "#dbdbdb"
						)
					) ) ),
					'params' => array(
						array(
							'type' => 'number_slider',
							'label' => __( 'Value', 'wpleadpages' ),
							'name' => 'value',
							'description' => __( 'Enter display value of the bar.', 'wpleadpages' ),
							'admin_label' => true,
							'options' 		=> array(
								'min'		=> 1,
								'max'		=> 100,
								'show_input'=> true,
							),
							'value' => '80'
						),
							array(
							'type' => 'text',
							'label' => __( 'Label', 'wpleadpages' ),
							'name' => 'label',
							'description' => __( 'Enter bar text title.', 'wpleadpages' ),
							'admin_label' => true,
						),
						array(
							'type' => 'colwlp_picker',
							'label' => __( 'Value Color', 'wpleadpages' ),
							'name' => 'value_color',
							'description' => __( 'Color of targeted value text.', 'wpleadpages' ),
						),
					
						array(
							'type' => 'colwlp_picker',
							'label' => __( 'Label Color', 'wpleadpages' ),
							'name' => 'label_color',
							'description' => __( 'Label text color', 'wpleadpages' ),
						),
						array(
							'type' => 'colwlp_picker',
							'label' => __( 'Progressbar Color', 'wpleadpages' ),
							'name' => 'prob_color',
							'description' => __( 'Customized progress bar color.', 'wpleadpages' ),
						),
						array(
							'type' => 'colwlp_picker',
							'label' => __( 'Progressbar background color', 'wpleadpages' ),
							'name' => 'prob_bg_color',
							'description' => __( 'Customized progress background bar color.', 'wpleadpages' ),
						),
					),
				),
				/*array(
					'type'			=> 'text',
					'label'			=> __( 'Wrapper class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
				)*/
			)

		),

		'wlp_button' => array(

			'name' => __('Button', 'wpleadpages'),
			'description' => __('Clickable CTA button', 'wpleadpages'),
			'icon' => 'wlp-icon-button',
			'category' => '',
			'css_box' => true,
			'live_editor' => $live_tmpl.'wlp_button.php',
			'params' => array(

				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'text_title',
					'description'	=> __( 'Enter button text.', 'wpleadpages' ),
					'value' 			=> 'Text title',
					'admin_label'	=> true
				),
				array(
					'type'			=> 'link',
					'label'			=> __( 'Link', 'wpleadpages' ),
					'name'			=> 'link',
					'description'	=> __( 'Add button target URL.', 'wpleadpages' ),
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Button size', 'wpleadpages' ),
					'name'			=> 'size',
					'description'	=> __( 'Select button size.', 'wpleadpages' ),
					'options'		=> array(
						'small' => __('Small', 'wpleadpages'),
						'normal' => __('Normal', 'wpleadpages'),
						'large' => __('Large', 'wpleadpages'),
						'custom' => __('Custom padding, front-size', 'wpleadpages'),
					),
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Padding', 'wpleadpages' ),
					'name'			=> 'padding_button',
					'description'	=> __( 'The CSS padding properties are used to generate space around content, (top, right, bottom, and left) . For example: "10px 25px" or "10px 25px 10px 25px"', 'wpleadpages' ),
					'relation'	=> array(
						'parent'	=> 'size',
						'show_when'	=> 'custom'
					),
					'value'			=> '10px 25px 10px 25px'
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Front size', 'wpleadpages' ),
					'name'			=> 'font_size_button',
					'description'	=> __( 'Font size for text in the button. For example: 14px', 'wpleadpages' ),
					'relation'	=> array(
						'parent'	=> 'size',
						'show_when'	=> 'custom'
					),
					'value'			=> '14px'
				),
				array(
					'type' 			=> 'checkbox',
					//'label'			=> __( 'Custom style', 'wpleadpages' ),
					'name'			=> 'custom_style',
					'description'	=> __('Show all related parameters.', 'wpleadpages'),
					'options'			=> array( 'yes' => __( 'Custom style', 'wpleadpages' ) ),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Border radius', 'wpleadpages' ),
					'name'			=> 'border_radius',
					'description'	=> __( 'Slide left or right to change the button corner radius.', 'wpleadpages' ),
					'value'			=> 3,
					'options' => array(
						'min' => 0,
						'max' => 1000,
						'unit' => 'px',
						'show_input' => true,
					),
					'relation'	=> array(
						'parent'	=> 'custom_style',
						'show_when'	=> 'yes'
					),
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Shape color', 'wpleadpages' ),
					'name'			=> 'bg_color',
					'description'	=> __( 'Shape color that changes when the mouse cursor hovers over the button.', 'wpleadpages' ),
					'relation'	=> array(
						'parent'	=> 'custom_style',
						'show_when'	=> 'yes'
					),
					'value'			=> '#fff'
					 
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Shape color hover', 'wpleadpages' ),
					'name'			=> 'bg_colwlp_hover',
					'description'	=> __( 'Button Shape color hover', 'wpleadpages' ),
					'relation'	=> array(
						'parent'	=> 'custom_style',
						'show_when'	=> 'yes'
					),
					 
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Text color', 'wpleadpages' ),
					'name'			=> 'text_color',
					'description'	=> __( 'Set color of the button text.', 'wpleadpages' ),
					'relation'	=> array(
						'parent'	=> 'custom_style',
						'show_when'	=> 'yes'
					),
					'value'			=> '#000'
					 
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Text color hover', 'wpleadpages' ),
					'name'			=> 'text_colwlp_hover',
					'description'	=> __( 'Set color of the button when mouse cursor hovers over it.', 'wpleadpages' ),
					'relation'	=> array(
						'parent'	=> 'custom_style',
						'show_when'	=> 'yes'
					),
					 
				),
				array(
					'type' 			=> 'checkbox',
					'name' 			=> 'show_icon',
					//'label' 		=> __( 'Show Icon?', 'wpleadpages' ),
					'description' 	=> '',
					'options' 		=> array(
						'yes' => __('Add icon to button', 'wpleadpages'),
					)
				),
				array(
					'type' 			=> 'icon_picker',
					'name'		 	=> 'icon',
					'label' 		=> __( 'Icon', 'wpleadpages' ),
					'admin_label' 	=> true,
					'description' 	=> __( 'Select icon for button', 'wpleadpages' ),
					'relation'		=> array(
						'parent'	=> 'show_icon',
						'show_when'	=> 'yes'
					)
				),
				array(
					'type' => 'dropdown',
					'name' => 'icon_position',
					'label' => __( 'Icon position', 'wpleadpages' ),
					'description' => '',
					'options' => array(
						'left' => __('Left', 'wpleadpages'),
						'center' => __('Center without text', 'wpleadpages'),
						'right' => __('Right', 'wpleadpages'),
					),
					'relation'		=> array(
						'parent'	=> 'show_icon',
						'show_when'	=> 'yes'
					)
				),
				/*array(
					'type'			=> 'text',
					'label'			=> __( 'Wrapper class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
				),*/
			)
		),

		'wlp_video_play' => array(

			'name' => __('Video', 'wpleadpages'),
			'description' => __('YouTube, Vimeo or MP4 video', 'wpleadpages'),
			'icon' => 'wlp-icon-play',
			'category' => '',
			'css_box' => true,
			'live_editor' => $live_tmpl.'wlp_video_play.php',
			'params' => array(
				
				array(
					'type' 			=> 'select',
					'name' 			=> 'source',
					'label' 		=> __( 'Source', 'wpleadpages' ),
					'description' 	=> __('Select video source', 'wpleadpages'),
					'options' 		=> array(
					'youtube' => __('Youtube or vimeo', 'wpleadpages'),
						'upload' => __('Media library', 'wpleadpages'),
						
					)
				),
				array(
					'type'			=> 'attach_media',
					'label'			=> __( 'Video upload', 'wpleadpages' ),
					'name'			=> 'video_upload',
					'description'	=> __( 'Select video from media library', 'wpleadpages' ),
					'admin_label'	=> true,
					'relation'		=> array(
						'parent'	=> 'source',
						'show_when' => 'upload'
					)
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Video link', 'wpleadpages' ),
					'name'			=> 'video_link',
					'description'	=> __( 'Enter the Youtube or Vimeo URL. For example: https://www.youtube.com/watch?v=VZAnXO0Y1Tg', 'wpleadpages' ),
					'admin_label'	=> true,
					'value'			=> 'https://www.youtube.com/watch?v=VZAnXO0Y1Tg',
					'relation'		=> array(
						'parent'	=> 'source',
						'show_when' => 'youtube'
					)
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( "Enter the video title. You can leave it blank if it's not needed", 'wpleadpages' ),
				),
				array(
					'type'			=> 'textarea',
					'label'			=> __( 'Description', 'wpleadpages' ),
					'name'			=> 'description',
					'description'	=> __( 'Enter video description.', 'wpleadpages' ),
				),
				array(
					'type' 			=> 'checkbox',
					'name' 	=> 'full_width',
					//'label' 		=> __( 'Video Fullwidth', 'wpleadpages' ),
					'description' 	=> __('Stretch the video to fit the content width.', 'wpleadpages'),
					'options' 		=> array(
						'yes' => __('Full width video', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Video Width', 'wpleadpages' ),
					'name'			=> 'video_width',
					'description'	=> __( 'Set video width.', 'wpleadpages' ),
					'value'			=> 600,
					'relation'		=> array(
						'parent'	=> 'full_width',
						'hide_when' => 'yes'
					)
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Video Height', 'wpleadpages' ),
					'name'			=> 'video_height',
					'description'	=> __( 'Set video height.', 'wpleadpages' ),
					'value'			=> 250,
				),
				array(
					'type' 			=> 'checkbox',
					'name' 	=> 'auto_play',
					//'label' 		=> __( 'Auto Play', 'wpleadpages' ),
					'description' 	=> __('Automatically play the video on page load.', 'wpleadpages'),
					'options' 		=> array(
						'yes' => __('Auto Play', 'wpleadpages'),
					)
				),
				/*array(
					'type'			=> 'text',
					'label'			=> __( 'Wrapper class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
				),*/
			)

		),
		'wlp_counter_box' => array(

			'name' => __('Counter Box', 'wpleadpages'),
			'description' => __('Animated counter box', 'wpleadpages'),
			'icon' => 'wlp-icon-counter',
			'category' => '',
			'live_editor' => $live_tmpl.'wlp_counter_box.php',
			'params'		=> array(
				array(
					'type'			=> 'text',
					'label'			=> __( 'Targeted number', 'wpleadpages' ),
					'name'			=> 'number',
					'description'	=> __( 'The targeted number to count up to (From zero).', 'wpleadpages' ),
					'admin_label'	=> true,
					'value'			=> '100'
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Label', 'wpleadpages' ),
					'name'			=> 'label',
					'description'	=> __( 'The text description of the counter.', 'wpleadpages' ),
					'admin_label'	=> true,
					'value'			=> 'Percent number'
				),
				array(
					'type' 			=> 'checkbox',
					'name' 			=> 'label_above',
					//'label' 		=> __( 'Label above number', 'wpleadpages' ),
					'description' 	=> __('Place the label above the number counting.', 'wpleadpages'),
					'options' 		=> array(
						'yes' => __('Label above number', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Style', 'wpleadpages' ),
					'name'			=> 'style',
					'description'	=> __( 'Select the style to display the counter box', 'wpleadpages' ),
					'options' => array(
						'1' => __( 'Style 1 (No icon)', 'wpleadpages' ),
						'2' => __( 'Style 2 (Box and icon)', 'wpleadpages' ),
						'3' => __( 'Style 3 (Icon & title)', 'wpleadpages' )
					),
				),
				array(
					'type'			=> 'icon_picker',
					'label'			=> __( 'Icon', 'wpleadpages' ),
					'name'			=> 'icon',
					'description'	=> __( 'Icon in counter box', 'wpleadpages' ),
					'relation'		=> array(
						'parent'	=> 'style',
						'show_when'	=> array( '2', '3' )
					)
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Number color', 'wpleadpages' ),
					'name'			=> 'number_color',
					'description'	=> __( '', 'wpleadpages' ),
					 
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Label color', 'wpleadpages' ),
					'name'			=> 'label_color',
					'description'	=> __( '', 'wpleadpages' ),
					 
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Icon color', 'wpleadpages' ),
					'name'			=> 'icon_color',
					'description'	=> __( '', 'wpleadpages' ),
					 
					'relation'		=> array(
						'parent'	=> 'style',
						'show_when'	=> array( '2', '3')
					)
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Box background color', 'wpleadpages' ),
					'name'			=> 'box_bg_color',
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> '#d9d9d9',
					'relation'		=> array(
						'parent'	=> 'style',
						'show_when' => '2'
					)
				),
				/*array(
					'type'			=> 'text',
					'label'			=> __( 'Wrapper class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
				),*/
			)

		),

		'wlp_post_type_list' => array(

			'name' => __('Post Type List', 'wpleadpages'),
			'description' => __('Posts you want to show', 'wpleadpages'),
			'icon' => 'wlp-icon-post',
			'category' => '',
			'params'		=> array(

				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( 'The title of the Post Type List. Leave blank if no title is needed.', 'wpleadpages' ),
					'value'			=> __( 'Recent post title', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Number of posts displayed', 'wpleadpages' ),
					'name'			=> 'number_post',
					'description'	=> __( 'The number of posts you want to show.', 'wpleadpages' ),
					'value'			=> '5',
					'admin_label'	=> true,
					'options' => array(
						'min' => 1,
						'max' => 12
					)
				),
				array(
					'type'			=> 'post_taxonomy',
					'label'			=> __( 'Content Type', 'wpleadpages' ),
					'name'			=> 'post_taxonomy',
					'description'	=> __( '', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Order by', 'wpleadpages' ),
					'name'			=> 'order_by',
					'description'	=> __( '', 'wpleadpages' ),
					'admin_label'	=> true,
					'options' 		=> array(
						'ID'		=> __('Post ID', 'wpleadpages'),
						'author'	=> __('Author', 'wpleadpages'),
						'title'		=> __('Title', 'wpleadpages'),
						'name'		=> __('Post name (post slug)', 'wpleadpages'),
						'type'		=> __('Post type (available since Version 4.0)', 'wpleadpages'),
						'date'		=> __('Date', 'wpleadpages'),
						'modified'	=> __('Last modified date', 'wpleadpages'),
						'rand'		=> __('Random order', 'wpleadpages'),
						'comment_count'	=> __('Number of comments', 'wpleadpages')
					)
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Order post', 'wpleadpages' ),
					'name'			=> 'order_list',
					'description'	=> __( '', 'wpleadpages' ),
					'admin_label'	=> true,
					'options' 		=> array(
						'ASC'		=> __('ASC', 'wpleadpages'),
						'DESC'		=> __('DESC', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show thumbnail', 'wpleadpages' ),
					'name'			=> 'thumbnail',
					'description'	=> __( 'Show the post thumbnail.', 'wpleadpages' ),
					'options' 		=> array(
						 'yes' => __('Show thumbnail', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'select',
					'label'			=> __( 'Image size', 'wpleadpages' ),
					'name'			=> 'image_size',
						'options' => array(
						'thumbnail'  => __('Thumbnail', 'wpleadpages'),
						'medium'  => __('Medium', 'wpleadpages'),
						'large' => __('Large', 'wpleadpages'),
					),
					'description'	=> __( 'Add your image size, For example: thumbnail, medium, large or full).', 'wpleadpages' ),
					'value'			=> 'thumbnail',
					'relation' 	=> array(
						'parent'	=> 'thumbnail',
						'show_when'		=> 'yes'
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show date', 'wpleadpages' ),
					'name'			=> 'show_date',
					'description'	=> __( 'Show the date of the post.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' => __('Show date', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show author', 'wpleadpages' ),
					'name'			=> 'show_author',
					'description'	=> __( 'Show the author of the post.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' => __('Show author', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show tags', 'wpleadpages' ),
					'name'			=> 'show_tags',
					'description'	=> __( 'Show the tags of the post.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' => __('Show tags', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show categories', 'wpleadpages' ),
					'name'			=> 'show_category',
					'description'	=> __( 'Show the categories of the post.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' => __('Show categories', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Number of words', 'wpleadpages' ),
					'name'			=> 'number_word',
					'description'	=> __( 'Show a certain number of words in each post.', 'wpleadpages' ),
					'value'			=> '30'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show "Read more" button', 'wpleadpages' ),
					'name'			=> 'show_button',
					'description'	=> __( 'Show the "Read more" button in the post.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' => __('Show "Read more" button', 'wpleadpages'),
					),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Read more text', 'wpleadpages' ),
					'name'			=> 'readmore_text',
					'description'	=> __( 'Edit the text that appears on the "Read more" button.', 'wpleadpages' ),
					'relation'		=> array(
						'parent'	=> 'show_button',
						'show_when' => 'yes'
					),
					'value'			=> 'Read more'
				),
				/*array(
					'type'			=> 'text',
					'label'			=> __( 'Wrapper class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
				)*/
			)
		),
		'wlp_carousel_images' => array(

			'name' => __('Image Slider', 'wpleadpages'),
			'description' => __('Animated Image Slider', 'wpleadpages'),
			'icon' => 'wlp-icon-icarousel',
			'category' => '',
			'params' => array(

				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( 'The title of the Image Carousel. Leave blank if no title is needed.', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type' 			=> 'attach_images',
					'label' 		=> __( 'Images', 'wpleadpages' ),
					'name'			=> 'images',
					'description' 	=> __( 'Select images from media library.', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'        	=> 'select',
					'label'     	=> __( 'Image size', 'wpleadpages' ),
					'name' 		 	=> 'img_size',
						'options' => array(
						'thumbnail'  => __('Thumbnail', 'wpleadpages'),
						'medium'  => __('Medium', 'wpleadpages'),
						'large' => __('Large', 'wpleadpages'),
					),
					'description' 	=> __( 'Set the image size : thumbnail, medium, large or full.', 'wpleadpages' ),
					'value'       	=> 'large',
				),
				array(
					'type'     		=> 'dropdown',
					'label'  	 	=> __( 'Onclick event', 'wpleadpages' ),
					'name'			=> 'onclick',
					'options' 		=> array(
						'none' => __( 'None', 'wpleadpages' ),
						'lightbox' => __( 'Open on lightbox', 'wpleadpages' ),
						'custom_link' => __( 'Open custom links', 'wpleadpages' )
					),
					'description'	=> __( 'Select the click event when users click on an image.', 'wpleadpages' )
				),
				array(
					'type' 			=> 'number_slider',
					'label' 		=> __( 'Items per slide', 'wpleadpages' ),
					'name' 			=> 'items_number',
					'description' 	=> __( 'The number of items displayed per slide.', 'wpleadpages' ),
					'admin_label'	=> true,
					'value'			=> '3',
					'options' => array(
						'min' => 1,
						'max' => 10,
						'show_input' => true
					)
				),
					array(
					'type'        	=> 'textarea',
					'label'     	=> __( 'Custom links', 'wpleadpages' ),
					'name'  	=> 'custom_links1',
					'description' 	=> __( 'Enter links for each slide (Note: divide links with linebreaks (Enter)).', 'wpleadpages' ),
					'relation'  	=> array(
						'parent'	=> 'onclick',
						'show_when' => 'custom_link1'
					)
				),
				array(
					'type' 			=> 'number_slider',
					'label' 		=> __( 'Speed', 'wpleadpages' ),
					'name' 			=> 'speed',
					'description' 	=> __( 'Set the speed at which auto playing sliders will transition (in second).', 'wpleadpages' ),
					 
					'admin_label'	=> true,
					'options' => array(
						'min' => 1,
						'max' => 30,
						'show_input' => true
					)
				),
				array(
					'type'        	=> 'textarea',
					'label'     	=> __( 'Custom links', 'wpleadpages' ),
					'name'  	=> 'custom_links',
					'description' 	=> __( 'Enter links for each slide (Note: divide links with linebreaks (Enter)).', 'wpleadpages' ),
					'relation'  	=> array(
						'parent'	=> 'onclick',
						'show_when' => 'custom_link'
					)
				),
				array(
					'type'        	=> 'dropdown',
					'label'     	=> __( 'Custom link target', 'wpleadpages' ),
					'name'  		=> 'custom_links_target',
					'description' 	=> __( 'Select how to open custom links.', 'wpleadpages' ),
					'options'       	=> array(
						'_self' => __( 'Same window', 'wpleadpages' ),
						'_blank' => __( 'New window', 'wpleadpages' )
					),
					'relation'  	=> array(
						'parent'	=> 'onclick',
						'show_when' => 'custom_link'
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Navigation', 'wpleadpages' ),
					'name'			=> 'navigation',
					'description'	=> __( 'Display the "Next" and "Prev" buttons.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' => __('Navigation', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Pagination', 'wpleadpages' ),
					'name'			=> 'pagination',
					'description'	=> __( 'Show the pagination.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' => __('Pagination', 'wpleadpages'),
					),
					 
				),
				/*array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Auto height', 'wpleadpages' ),
					'name'			=> 'auto_height',
					'description'	=> __( 'Add height to div "owl-wrapper-outer" so you can use diffrent heights on slides. Use it only for one item per page setting.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' => __('Auto height', 'wpleadpages'),
					)
				),*/
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Auto Play', 'wpleadpages' ),
					'name'			=> 'auto_play',
					'description'	=> __( 'The carousel automatically plays when site loaded.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' 		=> __('Auto Play', 'wpleadpages'),
					),
					 
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Progress Bar', 'wpleadpages' ),
					'name'			=> 'progress_bar',
					'description'	=> __( 'Visualize the progression of displaying photos.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' => __('Progress Bar', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show thumbnail', 'wpleadpages' ),
					'name'			=> 'show_thumb',
					'description'	=> __( 'Show the thumbnails in carousel.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' => __('Show thumbnail', 'wpleadpages'),
					)
				),
				/*array(
					'type' => 'text',
					'label' => __( 'Wrapper class name', 'wpleadpages' ),
					'name' => 'wrap_class',
					'description' => __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' )
				),*/
			)

		),

		'wlp_carousel_post' => array(

			'name' => __('Post Slider', 'wpleadpages'),
			'description' => __('Animated post slider', 'wpleadpages'),
			'icon' => 'wlp-icon-pcarousel',
			'category' => '',
			'params' => array(

				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( 'The title of the Post Carousel. Leave blank if no title is needed.', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'post_taxonomy',
					'label'			=> __( 'Content Type', 'wpleadpages' ),
					'name'			=> 'post_taxonomy',
					'description'	=> __( 'Choose supported content type such as post, custom post type, etc.', 'wpleadpages' ),
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Order by', 'wpleadpages' ),
					'name'			=> 'order_by',
					'description'	=> __( '', 'wpleadpages' ),
					'admin_label'	=> true,
					'options' 		=> array(
						'ID'		=> __('Post ID', 'wpleadpages'),
						'author'	=> __('Author', 'wpleadpages'),
						'title'		=> __('Title', 'wpleadpages'),
						'name'		=> __('Post name (post slug)', 'wpleadpages'),
						'type'		=> __('Post type (available since Version 4.0)', 'wpleadpages'),
						'date'		=> __('Date', 'wpleadpages'),
						'modified'	=> __('Last modified date', 'wpleadpages'),
						'rand'		=> __('Random order', 'wpleadpages'),
						'comment_count'	=> __('Number of comments', 'wpleadpages')
					)
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Order post', 'wpleadpages' ),
					'name'			=> 'order_list',
					'description'	=> __( '', 'wpleadpages' ),
					'admin_label'	=> true,
					'options' 		=> array(
						'ASC'		=> __('ASC', 'wpleadpages'),
						'DESC'		=> __('DESC', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Number of posts displayed', 'wpleadpages' ),
					'name'			=> 'number_post',
					'description'	=> __( 'The number of posts you want to show.', 'wpleadpages' ),
					'value'			=> '5',
					'admin_label'	=> true,
					'options' => array(
						'min' => 1,
						'max' => 20
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show thumbnail', 'wpleadpages' ),
					'name'			=> 'thumbnail',
					'description'	=> __( 'Show the post thumbnail.', 'wpleadpages' ),
					'options' 		=> array(
						'yes'		=> __('Show thumbnail', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'select',
					'label'			=> __( 'Image size', 'wpleadpages' ),
					'name'			=> 'image_size',
						'options' => array(
						'thumbnail'  => __('Thumbnail', 'wpleadpages'),
						'medium'  => __('Medium', 'wpleadpages'),
						'large' => __('Large', 'wpleadpages'),
					),
					'description'	=> __( 'Set the image size : thumbnail, medium, large or full.', 'wpleadpages' ),
					'value'			=> 'thumbnail',
					'relation' 	=> array(
						'parent'	=> 'thumbnail',
						'show_when'		=> 'yes'
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show date', 'wpleadpages' ),
					'name'			=> 'show_date',
					'description'	=> __( 'Show the post date.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' 		=> __('Show date', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Show "Read more" button', 'wpleadpages' ),
					'name'			=> 'show_button',
					'description'	=> __( 'Show "Read more" button in the post.', 'wpleadpages' ),
					'options' 		=> array(
						'yes'		=> __('Show "Read more" button', 'wpleadpages'),
					),
					'value'			=> 'yes'
				),
				array(
					'type' 			=> 'number_slider',
					'label' 		=> __( 'Items per slide', 'wpleadpages' ),
					'name' 	=> 'items_number',
					'description' 	=> __( 'The number of items displayed per slide.', 'wpleadpages' ),
					'value'			=> '3',
					'options' => array(
						'min' => 1,
						'max' => 10
					)
				),
				array(
					'type' 			=> 'number_slider',
					'label' 		=> __( 'Speed', 'wpleadpages' ),
					'name' 			=> 'speed',
					'description' 	=> __( 'Set the speed at which autoplaying sliders will transition in second.', 'wpleadpages' ),
					'value'			=> 500,
					'options' => array(
						'min' => 100,
						'max' => 1500,
						'show_input' => true
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Navigation', 'wpleadpages' ),
					'name'			=> 'navigation',
					'description'	=> __( 'Display the "Next" and "Prev" buttons.', 'wpleadpages' ),
					'options' 		=> array(
						'yes'		=> __('Navigation', 'wpleadpages'),
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Pagination', 'wpleadpages' ),
					'name'			=> 'pagination',
					'description'	=> __( 'Show the pagination.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' 		=> __('Pagination', 'wpleadpages'),
					),
					'value'			=> 'yes'
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Auto height', 'wpleadpages' ),
					'name'			=> 'auto_height',
					'description'	=> __( 'Add height to owl-wrapper-outer so you can use diffrent heights on slides. Use it only for one item per page setting.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' 		=> __('Auto height', 'wpleadpages'),
					),
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Auto Play', 'wpleadpages' ),
					'name'			=> 'auto_play',
					'description'	=> __( 'The carousel automatically plays when site loaded.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' 		=> __('Auto Play', 'wpleadpages'),
					),
					'value'			=> 'yes'
				),
				/*array(
					'type' => 'text',
					'label' => __( 'Wrapper class name', 'wpleadpages' ),
					'name' => 'wrap_class',
					'description' => __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' )
				),*/

			)
		),

		'wlp_image_gallery' => array(

			'name' => __('Image Gallery', 'wpleadpages'),
			'description' => __('Beautiful Image Gallery', 'wpleadpages'),
			'icon' => 'wlp-icon-gallery',
			'category' => '',
			'params' => array(

				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( 'The title of the Image Gallery. Leave blank if no title is needed.', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'attach_images',
					'label'			=> __( 'Images', 'wpleadpages' ),
					'name'			=> 'images',
					'description'	=> __( 'Upload multiple image to the carousel with the SHIFT key holding.', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Gallery type', 'wpleadpages' ),
					'name'			=> 'type',
					'description'	=> __( 'Select the gallery presentation type.', 'wpleadpages' ),
					'options' 		=> array(
						'grid' 		=> __( 'Images grid', 'wpleadpages' ),
						'slider' 	=> __( 'Slider', 'wpleadpages' ),
					),
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Image masonry', 'wpleadpages' ),
					'name'			=> 'image_masonry',
					'description'	=> __( 'Masonry is a JavaScript grid layout library.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' 		=> __('Image masonry', 'wpleadpages'),
					),
					'relation' 	=> array(
						'parent'	=> 'type',
						'show_when' => array('grid')
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Auto Play', 'wpleadpages' ),
					'name'			=> 'auto_rotate',
					'description'	=> __( 'Slider automatically plays when site loaded.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' 		=> __('Auto Play', 'wpleadpages'),
					),
					'relation' 	=> array(
						'parent'	=> 'type',
						'show_when' => array('slider')
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Navigation', 'wpleadpages' ),
					'name'			=> 'navigation',
					'description'	=> __( 'Display the "Next" and "Prev" buttons.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' 		=> __('Navigation', 'wpleadpages'),
					),
					'relation' 	=> array(
						'parent'	=> 'type',
						'show_when' => array('slider')
					)
				),
				array(
					'type'			=> 'checkbox',
					//'label'			=> __( 'Pagination', 'wpleadpages' ),
					'name'			=> 'pagination',
					'description'	=> __( 'Show the pagination.', 'wpleadpages' ),
					'options' 		=> array(
						'yes' 		=> __('Pagination', 'wpleadpages'),
					),
					'relation' 	=> array(
						'parent'	=> 'type',
						'show_when' => array('slider')
					)
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Slider width', 'wpleadpages' ),
					'name'			=> 'slider_width',
					'description'	=> __( 'Wrapper slider width, unit (px) or (%)', 'wpleadpages' ),
					'relation' 	=> array(
						'parent'	=> 'type',
						'show_when' => array('slider')
					),
					'value'			=> '400'
				),
				array(
					'type'			=> 'select',
					'label'			=> __( 'Image size', 'wpleadpages' ),
					'name'			=> 'image_size',
						'options' => array(
						'thumbnail'  => __('Thumbnail', 'wpleadpages'),
						'medium'  => __('Medium', 'wpleadpages'),
						'large' => __('Large', 'wpleadpages'),
					),
					'description'	=> __( 'Set the image size : thumbnail, medium, large or full.', 'wpleadpages' ),
					'value'			=> 'full'
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Onclick event', 'wpleadpages' ),
					'name'			=> 'click_action',
					'description'	=> __( 'Select the click event when users click on an image.', 'wpleadpages' ),
					'options' 		=> array(
						'none' 			=> __( 'No action', 'wpleadpages' ),
						'large_image' 	=> __( 'Open large image', 'wpleadpages' ),
						'lightbox' 		=> __( 'Open on lightbox', 'wpleadpages' ),
						'custom_link' 	=> __( 'Open on custom link', 'wpleadpages' )
					),
					'relation' 	=> array(
						'parent'	=> 'type',
						'show_when' => 'grid'
					)
				),
				array(
					'type'			=> 'textarea',
					'label'			=> __( 'Custom links', 'wpleadpages' ),
					'name'			=> 'custom_links',
					'description'	=> __( 'Each custom link per new line and corresponding to each image uploaded', 'wpleadpages' ),
					'relation'	=> array(
						'parent'	=> 'click_action',
						'show_when'	=> 'custom_link'
					)
				),
				/*array(
					'type'			=> 'text',
					'label'			=> __( 'Wrapper class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
				),*/


			)
		),

		'wlp_coundown_timer' => array(
			'name' => __('Countdown Timer', 'wpleadpages'),
			'description' => __('Countdown/Scarcity Timer', 'wpleadpages'),
			'icon' => 'wlp-icon-coundown',
			'category' => '',
			'css_box' => true,
			'params' => array(

				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( 'The title of Countdown Timer. Leave blank if no title is needed.', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Timer Style', 'wpleadpages' ),
					'name'			=> 'timer_style',
					'options'		=> array(
						'1' => __( 'Digit and Unit Side by Side', 'wpleadpages' ),
						'2' => __( 'Digit and Unit Up and Down', 'wpleadpages' ),
						'3' => __( 'Custom style template', 'wpleadpages' )
					),
					'description'	=> __( 'Select presentation style of the countdown timer.', 'wpleadpages' ),
				),
				array(
					'type'			=> 'textarea',
					'label'			=> __( 'Custom template', 'wpleadpages' ),
					'name'			=> 'custom_template',
					'description'	=> __( "For example: %D days %H:%M:%S.\n --- %Y: \"years\", %m: \"months\", %n: \"daysToMonth\", %w: \"weeks\", %d: \"daysToWeek\", %D: \"totalDays\", %H: \"hours\", %M: \"minutes\", %S: \"seconds\"", 'wpleadpages' ),
					'relation'	=> array(
						'parent'	=> 'timer_style',
						'show_when'	=> '3'
					)
				),
				array(
					'type'			=> 'date_picker',
					'label'			=> __( 'Date time', 'wpleadpages' ),
					'name'			=> 'datetime',
					'description'	=> __( 'Target date For Countdown.', 'wpleadpages' ),
					'admin_label'	=> true
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Background color group', 'wpleadpages' ),
					'name'			=> 'bgcolwlp_group',
					'description'	=> __( 'Set background color for each group (days, hours, minutes, seconds)', 'wpleadpages' )
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Background color digit', 'wpleadpages' ),
					'name'			=> 'bgcolwlp_digit',
					'description'	=> __( 'Set background color for digit', 'wpleadpages' ),
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Text Color', 'wpleadpages' ),
					'name'			=> 'text_color',
					'description'	=> __( 'Set color for timer digit text', 'wpleadpages' ),
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Unit Color', 'wpleadpages' ),
					'name'			=> 'unit_color',
					'description'	=> __( 'Set color of the Timer Unit text.', 'wpleadpages' ),
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Digit Text Size', 'wpleadpages' ),
					'name'			=> 'digit_text_size',
					'description'	=> __( 'Set font size of the Timer Digit Text.', 'wpleadpages' ),
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Unit Text Size', 'wpleadpages' ),
					'name'			=> 'unit_text_size',
					'description'	=> __( 'Set font size of the Timer Unit text.', 'wpleadpages' ),
				),
				/*array(
					'type'			=> 'text',
					'label'			=> __( 'Wrapper class name', 'wpleadpages' ),
					'name'			=> 'wrap_class',
					'description'	=> __( 'Custom class for wrapper of the shortcode widget.', 'wpleadpages' ),
				),
				array(
					'type' 			=> 'css_editor',
					'label' 		=> __( 'CSS box', 'wpleadpages' ),
					'name' 			=> 'css',
					'description'	=> __( 'Default Design Options tab on or, apply for wrapper of box', 'wpleadpages' ),
					'group' 		=> __( 'Design Options', 'wpleadpages' ),
				)*/

			)
		),
		
		'wlp_optinform' => array(
			'name' => __('Optin Form', 'wpleadpages'),
			'description' => __('Optin Form/subscriber form', 'wpleadpages'),
			'icon' => 'wlp-icon-optin', 
			'category' => '',
			'css_box' => true,
			'params' => array(

				array(
					'type'			=> 'text',
					'label'			=> __( 'Title', 'wpleadpages' ),
					'name'			=> 'title',
					'description'	=> __( 'Enter form title. You can leave it blank if it\'s not needed.', 'wpleadpages' ),
				),
				array(
					'type' 			=> 'optin_radio',
					'label' 		=> __( 'Fields', 'wpleadpages' ),
					'name' 			=> 'field_email',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array( 'email' => 'Email' ),
					'value'			=> 'email'
				),
				array(
					'type' 			=> 'checkbox',
					'label' 		=> __( '', 'originbuilder' ),
					'name' 			=> 'field_name_ck',
					'description'	=> __( '', 'originbuilder' ),
					'options'		=> array( 'yes' => 'Name'),
					'value'			=> ''
				),
				array(
					'type' 			=> 'animate_radio',
					'label' 		=> __( '', 'originbuilder' ),
					'name' 			=> 'field_name',
					'description'	=> __( '', 'originbuilder' ),
					'relation'	=> array(
						'parent'	=> 'field_name_ck',
						'show_when'	=> 'yes'
					),
					'options'		=> array( 'name' => 'Full Name', 'separate' => 'Separate First and Last names'),
					'value'			=> ''
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Enter placeholder for email field', 'originbuilder' ),
					'name'			=> 'placeholder_email_name',
					'description'	=> __( '', 'originbuilder' ),
					'value'			=> 'Enter Your Email Address'
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Enter placeholder for full name field', 'originbuilder' ),
					'name'			=> 'placeholder_full_name',
					'description'	=> __( '', 'originbuilder' ),
					'relation'	=> array(
						'parent'	=> 'field_name',
						'show_when'	=> 'name'
					),
					'value'			=> 'Enter Your Name'
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Enter placeholder for first names field', 'originbuilder' ),
					'name'			=> 'placeholder_separate_fname',
					'description'	=> __( '', 'originbuilder' ),
					'relation'	=> array(
						'parent'	=> 'field_name',
						'show_when'	=> 'separate'
					),
					'value'			=> 'Enter Your First Name'
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Enter placeholder for last names field', 'originbuilder' ),
					'name'			=> 'placeholder_separate_lname',
					'description'	=> __( '', 'originbuilder' ),
					'relation'	=> array(
						'parent'	=> 'field_name',
						'show_when'	=> 'separate'
					),
					'value'			=> 'Enter Your Last Name'
				),
				
				array(
					'type' 			=> 'optin_dropdown',
					'label' 		=> __( 'Email service provider', 'wpleadpages' ),
					'name' 			=> 'responder',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> $responder,
				),
				array(
					'type' 			=> 'optinlist_dropdown',
					'label' 		=> __( 'List', 'wpleadpages' ),
					'name' 			=> 'list_id',
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> ''
				),
				array(
					'type' 			=> 'checkbox',
					'label' 		=> __( '', 'originbuilder' ),
					'name' 			=> 'custom_field_ck',
					'description'	=> __( '', 'originbuilder' ),
					'options'		=> array( 'yes' => 'Add Other Field'),
					'relation'	=> array(
						'parent'	=> 'responder',
						'show_when' => array('Mailchimp','Aweber','GetResponse','ConstantContact','iContact','CampaignMonitor')
					),
				),  
				 array(
					'type' => 'group',
					'params' 		=>$optinform_custom,
					'name' 			=> 'custom_field_gp',
					'description'	=> __( '', 'originbuilder' ),
					'relation'	=> array(
						'parent'	=> 'custom_field_ck',
						'show_when'	=> 'yes'
					),
					
				), 
					array(
					'type' 			=> 'checkbox',
					'label' 		=> __( '', 'wpleadpages' ),
					'name' 			=> 'custom_emailsend_ck',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array( 'yes' => 'Mail send to Particular email'),
					
				), 
				array(
					'type'			=> 'text',
					'label'			=> __( 'Email', 'wpleadpages' ),
					'name'			=> 'custom_emailsend',
					'description'	=> __( '', 'wpleadpages' ),
					'relation'	=> array(
						'parent'	=> 'custom_emailsend_ck',
						'show_when'	=> 'yes'
					),
					'value'			=> 'abc@somedomain.com'
					 
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Subject', 'wpleadpages' ),
					'name'			=> 'custom_subjectsend',
					'description'	=> __( '', 'wpleadpages' ),
					'relation'	=> array(
						'parent'	=> 'custom_emailsend_ck',
						'show_when'	=> 'yes'
					),
					'value'			=> 'WP Lead Capturing Pages Inquiry'
					 
				), 
				array( 
					'type'			=> 'text',
					'label'			=> __( 'From Email', 'wpleadpages' ),
					'name'			=> 'custom_fromemail',
					'description'	=> __( '', 'wpleadpages' ),
					'relation'	=> array(
						'parent'	=> 'custom_emailsend_ck',
						'show_when'	=> 'yes'
					),
					'value'			=> 'xyz@domain.com'
					 
				),
				array(
					'type' 			=> 'optinlist_hidden',
					'label' 		=> __( '', 'wpleadpages' ),
					'name' 			=> 'list',
					'admin_label'	=> true,
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> ''
				),
				array(
					'type' 			=> 'dropdown',
					'label' 		=> __( 'Success action', 'wpleadpages' ),
					'name' 			=> 'successaction',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array( 'no' => 'Redirect to new page', 'yes' => 'Show a Thank You message'),
				),
				array(
					'type' 			=> 'text',
					'label' 		=> __( 'Success message', 'wpleadpages' ),
					'name' 			=> 'successmsg',
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> 'Thank you for subscribing. Please check your email to confirm your subscription',
					'relation'	=> array(
						'parent'	=> 'successaction',
						'show_when'	=> 'yes'
					)
				), 
				array(
					'type' 			=> 'text',
					'label' 		=> __( 'Redirect page url', 'wpleadpages' ),
					'name' 			=> 'redirecturl',
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> '', 
					'relation'	=> array(
						'parent'	=> 'successaction',
						'show_when'	=> 'no'
					)
				),
				array(
					'type' 			=> 'checkbox',
					'label' 		=> __( '', 'wpleadpages' ),
					'name' 			=> 'new_window',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array( 'yes' => 'Open in a new tab'),
					'relation'	=> array(
						'parent'	=> 'successaction',
						'show_when'	=> 'no'
					)
				),
				array(
					'type' 			=> 'dropdown',
					'label' 		=> __( 'Form size', 'wpleadpages' ),
					'name' 			=> 'form_size',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array( 'normal' => 'Normal', 'small' => 'Small', 'large' => 'Large' ),
					'value'			=> 'name'
				),
				array(
					'type'			=> 'text',
					'label'			=> __( 'Button text', 'wpleadpages' ),
					'name'			=> 'btn_txt',
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> 'Subscriber'
				),
				array(
					'type'			=> 'dropdown',
					'label'			=> __( 'Form alignment', 'originbuilder' ),
					'name'			=> 'title_align',
					'description'	=> __( '', 'originbuilder' ),
					'options'		=> array(
						'left'	=> 'left',
						'right'	=> 'right',
						'center'	=> 'center'
					),
					'value'			=> 'center'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Title color', 'wpleadpages' ),
					'name'			=> 'title_clr',
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> '#ffffff'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Button background color', 'wpleadpages' ),
					'name'			=> 'btn_bgclr',
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> '#29b682'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Button hover background color', 'wpleadpages' ),
					'name'			=> 'btn_hover_bgclr',
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> '#29b682'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Button text color', 'wpleadpages' ),
					'name'			=> 'btn_clr',
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> '#ffffff'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Button hover text color', 'wpleadpages' ),
					'name'			=> 'btn_hover_clr',
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> '#ffffff'
				),
				array(
					'type' 			=> 'dropdown',
					'label' 		=> __( 'Button Alignment', 'wpleadpages' ),
					'name' 			=> 'btn_align',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array( 'left' => 'Left', 'center' => 'Center', 'right' => 'Right' ),
					'value'			=> 'left'
				),
				array(
					'type'			=> 'colwlp_picker',
					'label'			=> __( 'Form background color', 'wpleadpages' ),
					'name'			=> 'form_bg_clr',
					'description'	=> __( '', 'wpleadpages' ),
					'value'			=> ''
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Form field border radius', 'wpleadpages' ),
					'name'			=> 'form_border_r',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array(
						'min'	=> 1,
						'max'	=> 100,
						'unit' => 'px',
						'show_input'=> true
					),
					'value'			=> 3
				),
				array(
					'type'			=> 'number_slider',
					'label'			=> __( 'Button border radius', 'wpleadpages' ),
					'name'			=> 'btn_border_r',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array(
						'min'	=> 1,
						'max'	=> 100,
						'unit' => 'px',
						'show_input'=> true
					),
					'value'			=> 3
				),
				array(
					'type' 			=> 'checkbox',
					'label' 		=> __( '', 'wpleadpages' ),
					'name' 			=> 'inline',
					'description'	=> __( '', 'wpleadpages' ),
					'options'		=> array( 'yes' => 'horizontal form' ),
					'value'			=> 'name'
				),
			)
		)

	)

);

