<?php
/**
*
*	Wp Lead Pages
*	(c) wpleadpages.com
*
*/
if(!defined('wlp_FILE')) {
	header('HTTP/1.0 403 Forbidden');
	exit;
}

global $wlp;

?>

<script type="text/html" id="tmpl-wlp-components-template">
	<div id="wlp-components">
		<ul class="wlp-components-categories">
			<li data-category="all" class="all active"><?php _e('All', 'wlp_composer'); ?></li>
			<?php
				
				$maps = $wlp->get_maps();
				$categories = array();
				
				foreach( $maps as $key => $map )
				{
					$category = isset( $map['category'] ) ? $map['category'] : '';
					if( !in_array( $category, $categories ) && $category != '' )
					{
						array_push( $categories, $category );
						echo '<li data-category="'.sanitize_title($category).'" class="'.sanitize_title($category).'">';
						echo esc_html($category);
						echo '</li>';
					}
				}
			?>
			<li data-category="wlp-wp-widgets" class="wlp-mostused mcl-mostused">
				  <?php _e('Most Used', 'wlp_composer'); ?>
			</li>
			<li data-category="wlp-content" class="wlp-content mcl-content">
			  <?php _e('Contents', 'wlp_composer'); ?>
			</li>
			<li data-category="wlp-clipboard" class="wlp-social mcl-social">
				  <?php _e('Social', 'wlp_composer'); ?>
			</li>
			<li data-category="wlp-clipboard" class="wlp-marketing mcl-marketing">
				 <?php _e('Marketing', 'wlp_composer'); ?>
			</li>
			<li data-category="wlp-wp-widgets" class="wlp-wp-widgets mcl-wp-widgets">
			  <?php _e('Wordpress Widgets', 'wlp_composer'); ?>
			</li>
		</ul>
		<ul class="wlp-components-list-main wlp-components-list all" style="display:block">
			<?php
  
				foreach( $maps as $key => $map )
				{
					if( !isset( $map['system_only'] ) )
					{echo $map['category'];
						$category = isset( $map['category'] ) ? $map['category'] : '';
						$name = isset( $map['name'] ) ? $map['name'] : '';
						$icon = isset( $map['icon'] ) ? $map['icon'] : '';
					?>
				<li <?php
								 
							?> data-category="<?php echo sanitize_title($category); ?>" data-name="<?php echo esc_attr( $key ); ?>" class="<?php echo esc_attr( $key ); ?>">
							<div>
								<span class="cpicon <?php echo esc_attr( $icon ); ?>"></span>
								<span class="cpdes">
									<strong><?php echo esc_html( $name ); ?></strong>
								</span>
								<span class="desc"><?php if( isset( $map['description'] ) && !empty( $map['description'] ) ){
									echo esc_attr( $map['description'] );
								} ?></span>
							</div>
						</li>
  
					<?php
					}	
				}	
			?>
		</ul>
	 
	</div>
</script>

 
 
<script type="text/html" id="tmpl-wlp-content-template"> 
 
		<ul class="wlp-components-list-main wlp-components-list wlp_content" style="display:none">
			 <?php
			 $maps = $wlp->get_maps();
              $con=array('wlp_box','wlp_column_text','wlp_icon','wlp_spacing','wlp_raw_code','wlp_title','wlp_pie_chart','wlp_button','wlp_post_type_list','wlp_progress_bars','wlp_post_type_list');
				foreach( $maps as $key => $map )
				{
					if( !isset( $map['system_only'] ) )
					{ 
						$category = isset( $map['category'] ) ? $map['category'] : '';
						$name = isset( $map['name'] ) ? $map['name'] : '';
						$icon = isset( $map['icon'] ) ? $map['icon'] : '';
					 if(in_array(esc_attr( $key ),$con)){ ?>
	<li   data-category="<?php echo sanitize_title($category); ?>" data-name="<?php echo esc_attr( $key ); ?>" class="<?php echo esc_attr( $key ); ?>">
							<div>
								<span class="cpicon <?php echo esc_attr( $icon ); ?>"></span>
								<span class="cpdes">
									<strong><?php echo esc_html( $name ); ?></strong>
								</span>
								<span class="desc"><?php if( isset( $map['description'] ) && !empty( $map['description'] ) ){
									echo esc_attr( $map['description'] );
								} ?></span>
							</div>
						</li>
					 
					<?php
					 }
					}	
				}	
			?>
		</ul>
	  
</script>


<script type="text/html" id="tmpl-wlp-mostused-template"> 
 
		<ul class="wlp-components-list-main wlp-components-list wlp_mostused" style="display:none">
			 <?php
			 $maps = $wlp->get_maps();
              $con=array('wlp_icon','wlp_box','wlp_column_text','wlp_spacing','wlp_raw_code','wlp_title','wlp_carousel_images','wlp_carousel_post','wlp_post_type_list','wlp_single_image','wlp_post_type_list');
				foreach( $maps as $key => $map )
				{
					if( !isset( $map['system_only'] ) )
					{ 
						$category = isset( $map['category'] ) ? $map['category'] : '';
						$name = isset( $map['name'] ) ? $map['name'] : '';
						$icon = isset( $map['icon'] ) ? $map['icon'] : '';
					 if(in_array(esc_attr( $key ),$con)){ ?>
			<li <?php
								 
							?> data-category="<?php echo sanitize_title($category); ?>" data-name="<?php echo esc_attr( $key ); ?>" class="<?php echo esc_attr( $key ); ?>">
							<div>
								<span class="cpicon <?php echo esc_attr( $icon ); ?>"></span>
								<span class="cpdes">
									<strong><?php echo esc_html( $name ); ?></strong>
								</span>
								<span class="desc"><?php if( isset( $map['description'] ) && !empty( $map['description'] ) ){
									echo esc_attr( $map['description'] );
								} ?></span>
							</div>
						</li>
					 
					<?php
					 }
					}	
				}	
			?>
		</ul>
	  
</script>

<script type="text/html" id="tmpl-wlp-social-template"> 
 
		<ul class="wlp-components-list-main wlp-components-list wlp_social" style="display:none">
			 <?php
			 $maps = $wlp->get_maps();
              $con=array('wlp_fb_recent_post','wlp_instagram_feed','wlp_twitter_feed');
				foreach( $maps as $key => $map )
				{
					if( !isset( $map['system_only'] ) )
					{echo $map['category'];
						$category = isset( $map['category'] ) ? $map['category'] : '';
						$name = isset( $map['name'] ) ? $map['name'] : '';
						$icon = isset( $map['icon'] ) ? $map['icon'] : '';
					 if(in_array(esc_attr( $key ),$con)){ ?>
			<li <?php
								 
							?> data-category="<?php echo sanitize_title($category); ?>" data-name="<?php echo esc_attr( $key ); ?>" class="<?php echo esc_attr( $key ); ?>">
							<div>
								<span class="cpicon <?php echo esc_attr( $icon ); ?>"></span>
								<span class="cpdes">
									<strong><?php echo esc_html( $name ); ?></strong>
								</span>
								<span class="desc"><?php if( isset( $map['description'] ) && !empty( $map['description'] ) ){
									echo esc_attr( $map['description'] );
								} ?></span>
							</div>
						</li>
					 
					<?php
					 }
					}	
				}	
			?>
		</ul>
	  
</script>


<script type="text/html" id="tmpl-wlp-marketing-template"> 
 
		<ul class="wlp-components-list-main wlp-components-list wlp_marketing" style="display:none">
			 <?php
			 $maps = $wlp->get_maps();
              $con=array('wlp_pie_chart','wlp_progress_bars','wlp_counter_box','wlp_video_play');
				foreach( $maps as $key => $map )
				{
					if( !isset( $map['system_only'] ) )
					{echo $map['category'];
						$category = isset( $map['category'] ) ? $map['category'] : '';
						$name = isset( $map['name'] ) ? $map['name'] : '';
						$icon = isset( $map['icon'] ) ? $map['icon'] : '';
					 if(in_array(esc_attr( $key ),$con)){ ?>
					<li   data-category="<?php echo sanitize_title($category); ?>" data-name="<?php echo esc_attr( $key ); ?>" class="<?php echo esc_attr( $key ); ?>">
							<div>
								<span class="cpicon <?php echo esc_attr( $icon ); ?>"></span>
								<span class="cpdes">
									<strong><?php echo esc_html( $name ); ?></strong>
								</span>
								<span class="desc"><?php if( isset( $map['description'] ) && !empty( $map['description'] ) ){
									echo esc_attr( $map['description'] );
								} ?></span>
							</div>
						</li>
					 
					<?php
					 }
					}	
				}	
			?>
		</ul>
	  
</script>


<script type="text/html" id="tmpl-wlp-wp-widgets-template">
<div id="wlp-wp-list-widgets"><?php 
	
	if( !function_exists( 'submit_button' ) ){
		function submit_button( $text = null, $type = 'primary', $name = 'submit', $wrap = true, $other_attributes = null ) {
			echo wlp_get_submit_button( $text, $type, $name, $wrap, $other_attributes );
		}
	}
	
	ob_start();
		@wp_list_widgets();
		$content = str_replace( array( '<script', '</script>' ), array( '&lt;script', '&lt;/script&gt;' ), ob_get_contents() );
	ob_end_clean();
	
	echo $content;
	
?></div>
</script>
<style>
.wlp_show_editor {
    min-width: 255px;
    border: 1px solid #e5e5e5;
    -webkit-box-shadow: 0 1px 1px rgba(0,0,0,.04);
    box-shadow: 0 1px 1px rgba(0,0,0,.04);
    background: #fff;
	float: left;
    width: 100%;
    padding-bottom: 20px;	
}
.wlp_show_editor h3{
    border-bottom: 1px solid #eee;
    margin: 0px;
}
.wlp_inside_editor {
    width: 98%;
    clear: both;
    padding: 25px 15px;
}
.wlp_left_img {
    float: left;
    width: 12%;
}
.wlp_right_text{
    float: left;
    width: 80%;	
}
.clear_both{
	clear: both;
}
.wlp_right_text h4 {
    font-size: 22px;
    margin-top: 0px;
    margin-bottom: -1px;
    color: #004a80;
}
.wlp_right_text p{
    color: #666;
    font-size: 12px;
    -line-height: 20px;
    margin-bottom: 16px;
}
.wlp_right_text a{
	background: #f1f1f1;
    background: -webkit-linear-gradient(top, #fff 0, #f1f1f1 100%);
    background: linear-gradient(to bottom,#fff 0,#f1f1f1 100%);
    border: 1px solid #ccc;
    border-radius: 25px!important;
    min-height: 15px;
    height: auto!important;
    width: auto!important;
    margin: 0!important;
    padding: 5px 15px!important;
    display: inline-block;
    font-size: 12px!important;
    font-weight: 700!important;
    line-height: 15px!important;
    color: #000!important;
    text-decoration: none!important;
    cursor: pointer;
    text-shadow: #fff 0 1px 0!important;
    font-family: "Helvetica Neue",Helvetica,Arial,sans-serif;
}
.wlp_right_text a:hover{
	border: 1px solid #aaa;
    box-shadow: 0 1px 0 0 rgba(0,0,0,.1);
    font-family: "Helvetica Neue",Helvetica,Arial,sans-serif;
    background: #f7f7f7;
    background: -webkit-linear-gradient(top, #fff 0, #f7f7f7 100%);
    background: linear-gradient(to bottom,#fff 0,#f7f7f7 100%);
}
@media screen and (max-width: 1200px){
.wlp_left_img {
    width: 25%;
}
.wlp_right_text{
    float: left;
    width: 60%;	
}		
}
@media screen and (max-width: 990px){
.wlp_left_img {
    width: 25%;
}
.wlp_right_text{
    float: left;
    width: 60%;	
}	
}
</style>
<script type="text/html" id="tmpl-wlp-message-template">
	<div id="wlp-container">
		<div class="wlp_show_editor">
			<h3 class="wlp_editor_head"><span>Wp Lead Pages</span></h3>
			<div class="wlp_inside_editor">
				<div class="wlp_left_img">
					<img src="<?php echo wlp_URL?>/assets/images/live_editor-alt.png"/>
				</div>
				<div class="wlp_right_text">
					<h4>Live Editor</h4>
					<p>Add and edit content, modify the layout.</p>
					<a href="<?php echo admin_url(); ?>options-general.php?page=wlp-sections-manager<?php
						global $post;
						echo '&editsid='.json_decode( base64_decode(get_post_meta( $post->ID, "__wlp_template_id_", true )));
					?>" class="wlp_edit_btn">Edit Now</a> 
                </div>
			</div>
			<div class="clear_both"></div>
		</div>
    </div> 
</script>
