<?php
/**
*
*	Wp Lead Pages
*	(c) wpleadpages.com
*
*/

if(!defined('ABSPATH')) {
	header('HTTP/1.0 403 Forbidden');
	exit;
}

	$wlp = wpleadpages::globe();
	$settings = $wlp->settings();
	$plugin_info = get_plugin_data( wlp_FILE );
	
?>
<style type="text/css">
	#wlp-settings  div.group input[type="text"],
	#wlp-settings  div.group input[type="password"]{
		height: 35px;
		box-shadow: none;
		display: block;
		margin-bottom: 5px;
		padding-left: 10px;
	}
	#wlp-settings div.wlp-badge{
		background-image: url('<?php echo wlp_URL; ?>/assets/images/logo.png');
		color: #dedede;
	}
	#wlp-settings div.p{
		padding-left: 10px; 
		padding-top:15px;
		display: block;
	}
	
	#wlp-settings p.radio{
		cursor: pointer;
	}
	.wlp-notice{
	    background: rgb(253, 255, 196);
	    display: inline-block;
	    width: 100%;
	    border-radius: 2px;
	    margin: 20px 0;
	    box-shadow: 0 0 1px 0 rgba(0,0,0,0.2);
	}
	.wlp-notice p{
		padding: 10px 20px;
		margin: 0px;
	}
   .about-wrap img{width:10%;height:auto;}
   .settings_page_origincomposer #wlp_general_setting{padding:0!important;}
   .settings_page_origincomposer #wlp_general_setting table td{padding:0!important;}
 	.settings_page_origincomposer, .settings_page_origincomposer #wpwrap {
  background: #fff none repeat scroll 0 0;
}
.settings_page_origincomposer #wpcontent {
  padding-left: 0;
}
.settings_page_origincomposer .about-wrap {
  margin: 155px 20px 0 !important;
  max-width: inherit;
}

#wlp-settings .about-text {
  color: #333 !important;
  font-size: 26px !important;
  font-weight: 600 !important;
  margin-top:40px!important;
  margin-bottom:16px!important;
}



#wlp-settings img {
  display: none;
  margin-right: 20px;
  width: 100px;
}
#wlp-settings #wlp_general_setting {
  padding: 0;
}

</style>
<div id="wlp-settings" class="wrap">
	<h1><img src="<?php echo wlp_URL; ?>/assets/images/get_logo.png" height="25" />Wp Lead Pages <span>Settings </span> </h1>
 
 
	<form method="post" action="options.php" enctype="multipart/form-data" id="wlp-settings-form">
		<?php settings_fields( 'origincomposer_group' ); ?>
		<div id="wlp_general_setting" class="group p">
			<?php
				
				$update_plugin = get_site_transient( 'update_plugins' );

			    if ( isset( $update_plugin->response[ wlp_BASE ] ) )
				{
			?>
			<div class="wlp-notice">
				<p>
					<i class="dashicons dashicons-warning"></i> 
					<?php
						printf( __('There is a new version of OriginBuilder available, please go to %s to update', 'wpleadpages'),	
							'<a href="'.admin_url('/plugins.php').'">Plugins</a>'
						); ?>.
				</p>
			</div>
			<?php			
				}
			?>
			<table class="form-table">
			
				<tbody>
						 <tr><th scope="row">             Supported WordPress content types   </th>
				
						<td>
							<?php
								
								$post_types = get_post_types( array( 'public' => true ) );
								$ignored_types = array('attachment');
								$settings_types = $wlp->get_content_types();
								$required_types = $wlp->get_required_content_types();
			
								foreach( $post_types as $type ){
									if( !in_array( $type, $ignored_types ) ){
										echo '<p class="radio"><input ';
										if( in_array( $type, $settings_types ) )
											echo 'checked ';
										if( in_array( $type, $required_types ) )
											echo 'disabled ';	
										echo'type="checkbox" name="wlp_options[content_types][]" value="'.esc_attr($type).'"> ';
										echo esc_html( $type );
										if( in_array( $type, $required_types ) )
											echo ' <i> (required)</i>';
										echo '</p>';
									}
								}
								
							?>
					 
						</td>
					</tr>
 
				</tbody>
			</table>
			
			<p class="submit">
				<input type="submit" class="button button-large button-primary" value="<?php _e('Save', 'wpleadpages'); ?>" />
    		</p>		
		</div>
		<div id="wlp_product_license" class="group p" style="display:none">
			<?php
			    if ( isset( $update_plugin->response[ wlp_BASE ] ) )
				{
			?>
			<div class="wlp-notice">
				<p>
					<i class="dashicons dashicons-warning"></i> 
					<?php
						printf( __('After submitting license informations, please go to %s to update', 'wpleadpages'),	
							'<a href="'.admin_url('/plugins.php').'">Plugins</a>'
						); ?>.
				</p>
			</div>
			<?php			
				}	
			?>
			<table class="form-table">
				<tbody>
					<tr>
						<th scope="row">
							<?php _e('Envato Username', 'wpleadpages'); ?>:
						</th>
						<td>
							<input type="text" class="regular-text" name="wlp_options[envato_username]" value="<?php echo esc_attr( $settings['envato_username'] ); ?>" />
							<span class="description">
							<p>
								<?php _e('Enter your Envato username.', 'wpleadpages'); ?>
							</p>		
						</td>
					</tr>
					<tr>
						<th scope="row">
							<?php _e('Secret API Key', 'wpleadpages'); ?>:
						</th>
						<td>
							<input type="password" class="regular-text" name="wlp_options[api_key]" value="<?php echo esc_attr( $settings['api_key'] ); ?>" />
							<span class="description">
							<p>
								<?php _e('Enter your Secret API Key', 'wpleadpages'); ?>. 
								<a href="http://docs.wpleadpages.com/documentation/how-to-get-api-key/" target=_blank>
									<?php _e('How to find API Key', 'wpleadpages'); ?>?
								</a>
							</p>	
						</td>
					</tr>
					<tr>
						<th scope="row">
							<?php _e('wpleadpages License Key', 'wpleadpages'); ?>:
						</th>
						<td>
							<input onchange="document.getElementById('wlp-stt-theme-key').value=''" id="wlp-stt-plugin-key" type="text" class="regular-text" name="wlp_options[license_key]" value="<?php echo esc_attr( $settings['license_key'] ); ?>" />
							<span class="description">
							<p>
								<?php _e('Enter Wp Lead Pages license key from CodeCanyon', 'wpleadpages'); ?>. 
								<a href="http://docs.wpleadpages.com/documentation/how-to-find-purchase-code/" target=_blank>
									<?php _e('How to find Purchase Code', 'wpleadpages'); ?>?
								</a>
							</p>
							<br />
						</td>
					</tr>
					<tr style="border: 1px dashed #aaa;display: none;">
						<th scope="row">
							<br />
							&nbsp; &nbsp; &nbsp; 
							<?php _e('Theme Purchase Code', 'wpleadpages'); ?>:
						</th>
						<td>
							<br />
							<input onchange="document.getElementById('wlp-stt-plugin-key').value=''" id="wlp-stt-theme-key" type="text" class="regular-text" name="wlp_options[theme_key]" value="<?php echo esc_attr( $settings['theme_key'] ); ?>" />
							<span class="description">
							<p>
								<?php _e('If you\'ve bought a theme which was included wpleadpages, You can use the Purchase Code of the theme to update wpleadpages', 'wpleadpages'); ?>. <br />
								<a href="http://docs.wpleadpages.com/documentation/how-to-find-theme-purchase-code/" target=_blank>
									<?php _e('How to find Theme Purchase Code', 'wpleadpages'); ?>?
								</a>
							</p>
							<br />	
						</td>
					</tr>
				</tbody>
			</table>
			<br />
			<p class="submit">
				<input type="submit" class="button button-large button-primary" value="<?php _e('Save Change', 'wpleadpages'); ?>" />
    		</p>			
		</div>
		<div id="wlp_about_us" class="group p" style="display:none">
			About Us
		</div>	
		
	</form>
</div>

<script>
    jQuery(document).ready(function($) {
        $('.nav-tab-wrapper a').on( 'click', function(e) {
	        var clicked = $(this).attr('href');
	        if( clicked.indexOf('#') == -1 )
	        	return true;
            $('.nav-tab-wrapper a').removeClass('nav-tab-active');
            $(this).addClass('nav-tab-active').blur();
            $('.group').hide();
            $(clicked).fadeIn();
            if (typeof(localStorage) != 'undefined' ) {
                localStorage.setItem('activeTab', clicked );
            }
            e.preventDefault();
        });
        $('p.radio').on('click',function(e){
	        if( e.target.tagName != 'INPUT' ){
	        	var inp = $(this).find('input').get(0);
	        	if( inp.disabled == true )
		        	e.preventDefault();
				else if( inp.checked == true )
	        		inp.checked = false;
	        	else inp.checked = true;	
	        }	
        });
        if (typeof(localStorage) != 'undefined' ) {
            activeTab = localStorage.getItem('activeTab');
            if( activeTab != undefined ){
	            $('.nav-tab-wrapper a[href='+activeTab+']').trigger('click');
            }
        }
        if(window.location.href.indexOf('#')>-1)
        	$('.nav-tab-wrapper a[href=#'+window.location.href.split('#')[1]+']').trigger('click');
    });
</script>