<?php
$data = get_option('wlp_subscriber_settings');
// print_r($data); 
class wlp_subscriber{
	
	public function switch_responder( $apikey, $action, $responder ){
		switch($responder){
			case 'ConstantContact':
				return $this->ConstantContact( $apikey, $action );
			break;
			case 'Mailchimp':
				return $this->Mailchimp( $apikey, $action );
			break;
			case 'SendReach':
				return $this->SendReach( $apikey, $action );
			break;
			case 'iContact':
				return $this->iContact( $apikey, $action );
			break;			
			case 'Aweber':
				return $this->Aweber( $apikey, $action, $responder );
			break;
			case 'GetResponse':
				return $this->GetResponse( $apikey, $action );
			break;
			case 'CampaignMonitor':
				return $this->CampaignMonitor( $apikey, $action );
			break;
			case 'GoToWebinar':
				return $this->GoToWebinar( $apikey, $action );
			break;
			case 'Benchmark':
				return $this->Benchmark( $apikey, $action );
			break;
			case 'ActiveCampaign':
				return $this->ActiveCampaign( $apikey, $action );
			break;
		}
	}
	
	public function GoToWebinar( $apikey, $action ){
		require_once wlp_PATH . '/subscriber/GoToWebinar/citrix.php';
		
		if($action === 'getList'){
			$citrix = new Citrix($apikey['consumer_key']);
			$params = array();
			$params['consumer_key'] = $apikey['consumer_key'];
			$params['consumer_secret'] = $apikey['consumer_secret'];
			$params['user_id'] = $apikey['user_id'];
			$params['password'] = $apikey['password'];
			$organizer_key = '';
			
			if(!$organizer_key){

				$url = 'https://api.citrixonline.com/oauth/access_token?grant_type=password&user_id='.$params['user_id'].'&password='.$params['password'].'&client_id='.$params['consumer_key'];
				$results = file_get_contents($url);
				if($results){
					$res = json_decode($results,true);

					$citrix->set_organizer_key($res['organizer_key']);
					$citrix->set_access_token($res['access_token']);

					$webinars = $citrix->citrixonline_get_list_of_webinars(1) ;

					$webinar_list = array();

					if(!isset($webinars['upcoming']['webinars']['errorCode'])){
						
						foreach($webinars['upcoming']['webinars'] as $webinar){
							$list[$webinar['webinarID']] = $webinar['subject'];
						}
						$result['list'] = $list;

					}else{
						$result = array('error'=>'There is no list in your account.');
					}

				}else{
					$result = array('error'=>'Error occur may be somethig wrong.');
				}
				
			}
		}
		
		if($action === 'subsCribe'){
			$citrix = new Citrix($apikey['consumer_key']);
			$params = array();
			$params['consumer_key'] = $apikey['consumer_key'];
			$params['consumer_secret'] = $apikey['consumer_secret'];
			$params['user_id'] = $apikey['user_id'];
			$params['password'] = $apikey['password'];
			
			try{
				$email = $_POST['email'];
				if (!empty($_POST['name']['fname'])){
					$fname = $_POST['fname'];
					$lname = $_POST['lname'];
				}else {
					$fname = '';
					$lname = '';
				}
				$listID = $_POST['listid'];
				$response = $citrix->citrixonline_create_registrant_of_webinar( $listID, array('first_name' => $fname, 'last_name' => $lname, 'email'=>$email));
				
				$result = array('success'=>'Subscribe successfully.');

			}catch (Exception $e) {
				$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			}
		}
		
		return $result;
	}
	
	public function CampaignMonitor( $apikey, $action ){
		
		if($action === 'getList'){
			require_once wlp_PATH . '/subscriber/CampaignMonitor/csrest_clients.php';
			$list = array();

			$wrap = new CS_REST_Clients($apikey["client_id"], $apikey["api_key"]);
			$cm_res = $wrap->get_lists();

			if ($cm_res->http_status_code != '200'){
				$result = array('error'=>'Error occur may be somethig wrong.');
			}else{

				if( count($cm_res->response) != 0 ){

					foreach ($cm_res->response as $solo_list){
						$list[$solo_list->ListID] = $solo_list->Name;
					}
					$result['list'] = $list;
					
				}
				else {
					$result = array('error'=>'There is no list in your account.');
				}

			}
		}
		
		if($action == 'subsCribe'){
			require_once wlp_PATH . '/subscriber/CampaignMonitor/csrest_subscribers.php';
			$key = $apikey["api_key"];
			$listID = $_POST['listid'];

			if(!empty($listID)){
				$wrap = new CS_REST_Subscribers($listID, $key);
			}

			$args = array(
				'EmailAddress' => $_POST['email'],
				'Resubscribe' => true
			);

			if (!empty($_POST['name'])){
				$args['name'] = $_POST['name'];
			}
			
			$arr = array();
				if($_POST['custom_field']){
				foreach($_POST['custom_field'] as $k=>$v){ 				
						$arr[] = array(
									'Key' => $k, 
									'Value' => $v
								);
					} 
				}
				if(!empty($arr)){
					$args['CustomFields'] = $arr;
				}
			

			$res = $wrap->add($args);
			
			$result = array('success'=>'Subscribe successfully.');
		}
		
		return $result;
	}
	
	public function GetResponse( $apikey, $action ){
		
		require_once wlp_PATH . '/subscriber/GetResponse/jsonRPCClient.php';
		
		if($action === 'getList'){
			$list = array();
			
			$api = new jsonRPCClient('http://api2.getresponse.com');
			try{
				$results = $api->get_campaigns($apikey["api_key"]);
				if( count($results) > 0 ) {

					foreach ($results as $k => $v){
						$list[$k] = $v['name'];
					}
					$result['list'] = $list;
				}else {
					$result = array('error'=>'There is no list in your account.'); // When no list found
				}
			}catch (Exception $e){
			   $result = array('error'=>'Error occur may be somethig wrong.'); // Invalid API key
			}
		}
		
		if($action == 'subsCribe'){
			$api = new jsonRPCClient('http://api2.getresponse.com');
			try{
				$listID = $_POST['listid'];
				if(!empty($listID)){
					$args = array(
						'campaign' => $listID,
						'email' => $_POST['email'],
						'cycle_day'=>0,
					);
				}

				if (!empty($_POST['name'])){
					$args['name'] = $_POST['name'];
				}
				$arr = array();
				if($_POST['custom_field']){
				foreach($_POST['custom_field'] as $k=>$v){ 
						$arr[] = array(
								'name'       => $k,
								'content'    => $v
							);
						
					} 
				}
				if(!empty($arr)){
					$args['customs'] = $arr;
				} 

				$api->add_contact($apikey["api_key"], $args);
				
				$result = array('success'=>'Subscribe successfully.');

			}catch (Exception $e){ 
				//$result = $e;
				$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			}
		}
		
		return $result;
		
	}
	
	public function Aweber( $apikey, $action, $responder ){
		
		require_once wlp_PATH . '/subscriber/Aweber/aweber_api.php';
		
		if(isset($apikey['access_secret'])){
			$consumer_key = $apikey['consumer_key'];
			$consumer_secret = $apikey['consumer_secret']; 
			$access_key = $apikey['access_key']; 
			$access_secret = $apikey['access_secret'];
		}
		
		if($action === 'getList'){
			$list = array();

			$descr = '';
			if(!isset($apikey['access_secret'])){
				try{
					list($consumer_key, $consumer_secret, $access_key, $access_secret) = AWeberAPI::getDataFromAweberID($apikey['aweber_code']);
				}catch (AWeberAPIException $exc){
					list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
					if(isset($exc->message))
					{
						$descr = $exc->message;
						$descr = preg_replace('/http.*$/i', '', $descr);	 # strip labs.aweber.com documentation url from error message
						$descr = preg_replace('/[\.\!:]+.*$/i', '', $descr); # strip anything following a . : or ! character
						$descr = '('.$descr.')';

					}
				}catch (AWeberOAuthDataMissing $exc){
					list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
				}catch (AWeberException $exc){
					list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
				}
			}

			if (!$access_secret){
				$result = array('error'=>'Error occur may be somethig wrong.');
			}else{
				$aweber = new AWeberAPI($consumer_key, $consumer_secret);
				$account = $aweber->getAccount($access_key, $access_secret);
				$aweber_result = $account->lists;
				if( $aweber_result->data['total_size'] != '' && $aweber_result->data['total_size'] != 0 ){
					foreach ($aweber_result->data['entries'] as $solo_list){
						$list[$solo_list['id']] = $solo_list['name'];
					} 
					$result['list'] = $list;
				}else {
					$result = array('error'=>'There is no list in your account.');
				}
				
				if(!isset($apikey['access_secret'])){
					$data = get_option('wlp_subscriber_settings');
					$api = $data[$responder]['aweber_code'];
					
					$data[$responder] = array(
						'aweber_code' => $apikey['aweber_code'],
						'consumer_key' => $consumer_key,
						'consumer_secret' => $consumer_secret,
						'access_key' => $access_key,
						'access_secret' => $access_secret
					);
					
					update_option('wlp_subscriber_settings', $data);
				}
				
			}
		}
		
		if($action == 'subsCribe'){
			try{

				$email = $_POST['email'];
				$listID = $_POST['listid'];

				$aweber = new AWeberAPI($consumer_key, $consumer_secret);

				$account = $aweber->getAccount($access_key, $access_secret);

				$aweber_list = $listID;
				$list = $account->loadFromUrl('/accounts/' . $account->id . '/lists/' . $aweber_list);
				
				$aweber_custom_fields = array();
					
				if($_POST['custom_field']){
				foreach($_POST['custom_field'] as $k=>$v){ 
						$aweber_custom_fields[$k] = $v;
					} 
				}	
					
				if(!empty($aweber_custom_fields)){
					$subscriber = array(
						'email' => $email,
						'custom_fields' => $aweber_custom_fields,
						'ip' => $_SERVER['REMOTE_ADDR']
					); 
				}else{
					$subscriber = array(
						'email' => $email,
						'ip' => $_SERVER['REMOTE_ADDR']
					);
				}
				
				if (!empty($_POST['name'])){
					$subscriber['name'] = $_POST['name'];
				}else {
					$fname = '';
				}

				$list->subscribers->create($subscriber);
				
				$result = array('success'=>'Subscribe successfully.');

			}catch (AWeberException $e){
				$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			}
		}
		
		return $result;
	}
	
	public function iContact( $apikey, $action ){
		require_once  wlp_PATH . '/subscriber/iContact/iContactApi.php';
		
		$list = $result = array();
		
		if($action === 'getList'){
			iContactApi::getInstance()->setConfig(array(
				'appId' => $apikey['app_id'],
				'apiPassword' => $apikey['app_password'],
				'apiUsername' => $apikey['login_email']
			));
			$oiContact = iContactApi::getInstance();
			
			try{
				$icontact_res = $oiContact->getLists();

				if( count($icontact_res) > 0 ) {
					foreach ($icontact_res as $solo_list){
						$list[$solo_list->listId] = $solo_list->name;
					}
				}else{
					$result = array('error'=>'There is no list in your account.');
				}

			}catch (Exception $oException){
				$result = array('error'=>'Error occur may be somethig wrong.');
			}
			
			$result['list'] = $list;
		}
		
		if($action == 'subsCribe'){
			$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			
			iContactApi::getInstance()->setConfig(array(
				'appId' => $apikey['app_id'],
				'apiPassword' => $apikey['app_password'],
				'apiUsername' => $apikey['login_email']
			));
			
			$email = $_POST['email'];
			$listID = $_POST['listid'];
			$oiContact = iContactApi::getInstance();

			if (!empty($_POST['name'])){
				$fname = $_POST['name'];
			}else {
				$fname = '';
			}
			$arr = array();
			if($_POST['custom_field']){
			foreach($_POST['custom_field'] as $k=>$v){ 				
					$arr[$k] = $v;
				}
			} 
						
			$res1 = $oiContact->addContact($email, null, null, $fname , '' , null, null, null, null, null, null, null, null, null,$arr);
			if ($res1->contactId){
				if ($oiContact->subscribeContactToList($res1->contactId, $listID, 'normal')){
					$result = array('success'=>'Subscribe successfully.');
				}
			}
		}
		
		return $result;
	}
	
	public function SendReach( $apikey, $action ){
		$result = array();
		define('publicKey',$apikey['public_key']);
		define('privateKey',$apikey['private_key']);
		
		require_once  wlp_PATH.'/subscriber/SendReach/setup.php';
		
		if($action === 'getList'){
			$endpoint = new MailWizzApi_Endpoint_Lists();

			$response = $endpoint->getLists($pageNumber = 1, $perPage = 10);
			$body = $response->body;
			
			$list = array();
			$bool = false;

			foreach($body as $key=>$val) {
				if( $val != 'success' ) {
					if( $val['count'] > 0 ) {

						foreach( $val['records'] as $solo_rec ) {
							$list[$solo_rec['general']['list_uid']] = $solo_rec['general']['name'];
							$bool = true;
						}
						
					}
				}
			}
			
			if($bool == true){
				$result['list'] = $list;
			}else{
				$result = array('error'=>'There is no list in your account.');
			}			
		}
		
		if($action == 'subsCribe'){

			$email = $_POST['email'];
			$listID = $_POST['listid'];
			$fname = '';
			if (!empty($_POST['name'])){
				$fname = $_POST['name'];
			}
			$endpoint   = new MailWizzApi_Endpoint_ListSubscribers();
			$response   = $endpoint->create($listID, array(
				'EMAIL' => $email,
				'FNAME' => $fname,
				'LNAME' => '',
			));
			$response   = $response->body;

			if ($response->itemAt('status') == 'success') {
				$result = array('success'=>'Subscribe successfully.');
			}
		}
		
		return $result;
		
	}
	
	public function ConstantContact( $apikey, $action ){
		require_once  wlp_PATH.'/subscriber/ConstantContact/class.cc.php';
		
		if($action === 'getList'){
			$cc = new cc($apikey['username'], $apikey['password']);

            $resultofcc = $cc->get_lists('lists');

            if ($resultofcc){
				
				if( count($resultofcc) > 0  ){
					
					foreach($resultofcc as $v){
						$list[$v['id']] = $v['Name'];
					}
					
					$result['list'] = $list;
					
				}else{
					$result = array('error'=>'There is no list in your account.');
				}
				
			}else{
				$result = array('error'=>'Error occur may be somethig wrong.');
			}
			
			return $result;
		}
		
		if($action == 'subsCribe'){
			$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			$cc = new cc($apikey['username'], $apikey['password']);
			
			$email = $_POST['email'];
			$listID = $_POST['listid'];

			$contact_list = $_POST['listid'];
			$extra_fields = array();
			if (!empty($_POST['name'])){
				$extra_fields['FirstName'] = $_POST['name'];
			}			
			if($_POST['custom_field']){
				foreach($_POST['custom_field'] as $k=>$v){ 
						$extra_fields[$k] = $v;
						
					} 
				}
			$contact = $cc->query_contacts($email);
			//print_r($_POST);			
			if (!$contact){
				//print_r($_POST);
				$new_id = $cc->create_contact($email, $contact_list, $extra_fields);
				if ($new_id){
					$result = array('success'=>'Subscribe successfully.');
				}
			}
			
			return $result;
		}
	}
	
	public function Mailchimp( $apikey, $action ){
		
		require_once  wlp_PATH.'/subscriber/Mailchimp/MailChimp.php';
		
		if($action === 'getList'){
			$key = $apikey['api_key'];
			
			$api = new Mailchimp( $key );
			$retval = $api->get('lists');
			
			if (!empty($retval['lists'])){
				if($retval['lists'] != 0){
					foreach ($retval['lists'] as $v){
						$list[$v['id']] = $v['name'];
					}
					
					$result['list'] = $list;
					
				}else{
					$result = array('error'=>'There is no list in your account.');
				}
			}else{
				$result = array('error'=>'Error occur may be somethig wrong.');
			}
			
			return $result;
		}
		
		if($action == 'subsCribe'){
			$key = $apikey['api_key'];
			
			$api = new Mailchimp( $key );
			
			$listID = $_POST['listid'];
			
			
			if($_POST['name']){
				$merge_vars['FNAME'] =$_POST['name'];
			}else{
				$merge_vars = array();
			} 
			
			
			if($_POST['custom_field']){
				foreach($_POST['custom_field'] as $k=>$v){ 
							$merge_vars[$k] = $v;
					} 
			}
	
			 if(!empty($listID)){
			 if(!empty($merge_vars)){
				$retval = $api->post('/lists/'.$listID.'/members', array(
												'email_address' => $_POST['email'],
												'merge_fields'  => $merge_vars,
												'status'        => 'subscribed'     
										));
										
			 }else{
			     	$retval = $api->post('/lists/'.$listID.'/members', array(
												'email_address' => $_POST['email'],
												'status'        => 'subscribed'     
										));
			 }
			} 
			
			if ($retval['status'] == 'subscribed'){
				$result = array('success'=>'Thank you, please check your email.');
			}else{
				$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			}
			
			return $result;
			
		}
		
	}
	public function Benchmark( $apikey, $action ){
		
		require_once  wlp_PATH.'/subscriber/Benchmark/BMEAPI.class.php';
		 
		if($action === 'getList'){			
			$username = $apikey['username'];
            $password = $apikey['password'];
            $apiURL = 'http://www.benchmarkemail.com/api/1.0/';
			$api = new BMEAPI($username, $password, $apiURL);
						
			if (!$api->errorCode){
				$retvals = $api->listGet("", 1, 10, "", "");
                    if ($retvals){	
					foreach($retvals as $retval)
                    {
						$list[$retval['id']] = $retval['listname'];
					}					
					$result['list'] = $list;
					
				}else{
					$result = array('error'=>'There is no list in your account.');
				}
			}else{
				$result = array('error'=>'Error occur may be somethig wrong.');
			}
			
			return $result;
		}
		
		if($action == 'subsCribe'){
			$benchmark_username = $apikey['username'];
            $benchmark_password = $apikey['password'];
            $benchmark_apiurl = 'http://www.benchmarkemail.com/api/1.0/';
			
			$email = $_POST['email'];
            if (!empty($_POST['name'])) {
                 $fname = $_POST['name'];
            } else {
				$fname = '';
            }
			$listID = $_POST['listid'];
			try
			{
				$api = new BMEAPI($benchmark_username, $benchmark_password, $benchmark_apiurl);
				$details[0]["email"] = $email;
				$details[0]["firstname"] = $fname;
				$details[0]["lastname"] = '';
				
				if(!empty($listID)){
					$result = $api->listAddContacts($listID, $details);
				}
				
				if ($api->errorCode == ''){
					$result = array('success'=>'Thank you, please check your email.');
				}elseif($api->errorCode == 214){
					$result = array('success'=>'This email already subscribe.');
				}else{
					$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
				}
				
				return $result;
			} catch (Exception $e){ }
		}
		
	}
	public function ActiveCampaign( $apikey, $action ){
		 if($action === 'getList'){
				$url = $apikey['api_url'];
                $key = $apikey['api_key'];
                $params = array(
                    'api_key'      => $key,
                    'api_action'   => 'list_paginator',
                    'api_output'   => 'json',
                    'somethingthatwillneverbeused' => '',
                    'sort' => '',
                    'offset' => 0,
                    'limit' => 20,
                    'filter' => 0,
                    'public' => 0,
                );
				$query = "";
                foreach( $params as $key => $value ) $query .= $key . '=' . urlencode($value) . '&';
                $query = rtrim($query, '& ');
                $url = rtrim($url, '/ ');

                if ( !function_exists('curl_init') ) { 
					$result = array('error'=>'Error occur may be somethig wrong.'); 
				}

                if ( $params['api_output'] == 'json' && !function_exists('json_decode') ) {
                    $result = array('error'=>'Error occur may be somethig wrong.');
                }
                $api = $url . '/admin/api.php?' . $query;

                $request = curl_init($api);
                curl_setopt($request, CURLOPT_HEADER, 0);
                curl_setopt($request, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($request, CURLOPT_FOLLOWLOCATION, true);
                $response = (string)curl_exec($request);
                curl_close($request); 

                if ( !$response ) { 
                   $result = array('error'=>'Error occur may be somethig wrong.');
                }
                $acresult = json_decode($response);
				 if( $acresult->result_code == 0 ) {
                    $result = array('error'=>'Error occur may be somethig wrong.');
                }
                else {
                    if ( $acresult->cnt == 0 ) {
                        $result = array('error'=>'There is no list in your account.');
                    }
                    else {
                            foreach ($acresult->rows as $solo_list)
                            {
                                $list_key = $solo_list->id;
                                $list_name = $solo_list->name;
								$list[$list_key] = $list_name;                               
                            }
							$result['list'] = $list;
                    }
                }
			
			return $result;
		}
		
		if($action == 'subsCribe'){			
			$url = $apikey['api_url'];
            $key = $apikey['api_key'];

				$params = array(
					'api_key'      => $key,
					'api_action'   => 'contact_add',
					'api_output'   => 'json'
				);
				
				$email = $_POST['email'];
				if (!empty($_POST['name']))	{
					$fname = $_POST['name'];
				} else {
					$fname = '';
				}
				$listID = $_POST['listid'];
				
				$post = array(
					'email'                    => $email,
					'first_name'               => $fname,
					'tags'                     => 'api',
					'p[1]'                   => $listID,
					'status[1]'              => 1,
					'instantresponders[123]' => 1
				);
				
				$query = "";
				foreach( $params as $key => $value ) $query .= $key . '=' . urlencode($value) . '&';
				$query = rtrim($query, '& ');

				$data = "";
				foreach( $post as $key => $value ) $data .= $key . '=' . urlencode($value) . '&';
				$data = rtrim($data, '& ');

				$url = rtrim($url, '/ ');

				$api = $url . '/admin/api.php?' . $query;

				$request = curl_init($api);
				curl_setopt($request, CURLOPT_HEADER, 0);
				curl_setopt($request, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($request, CURLOPT_POSTFIELDS, $data);
				curl_setopt($request, CURLOPT_FOLLOWLOCATION, true);
				$response = (string)curl_exec($request);
				curl_close($request);

				if ( $response ) { 
					$acresult = json_decode($response);
					if( $acresult->result_code != 0) {
						$result = array('success'=>'Thank you, please check your email.');
					}else{
						$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
					}
				}			
				return $result;
			} 
		
	}
	
	// Send mail Particular email
	public function send_customemail(){
		
		 $to = $_POST['custom_emailsend'];
         $subject = $_POST['custom_subjectsend'];
         
         $message = ""; 
		 if($_POST['name']){
				$message .= "<p>Name : ".$_POST['name'];
		 }
		 if($_POST['email']){
         $message .= "<p>Email : ".$_POST['email'].'</p>';
         }
			
		 if($_POST['custom_field']){
				foreach($_POST['custom_field'] as $k=>$v){ 
					$message .=	'<p>'.$k.' : '.$v.'</p>';
					} 
			}
         $header = "From:".$_POST['custom_fromemail']." \r\n";       
         $header .= "MIME-Version: 1.0\r\n";
         $header .= "Content-type: text/html\r\n";         
         mail ($to,$subject,$message,$header);
		
	}
	
}